Attribute VB_Name = "Module13"

Public Sub Casc_Main_Part()
  Static sA, sX
  ReDim Eff_Grund(QuenchDat(ikb).nfm)
  Dim pp(9), ee(9), IGG(12) 'Hilfsgrssen Eff-Way, p-Way
  Call Subs("  Casc_Main_Part " & NUCLIDE(inuc).Nuc & ": Casc" & icasc)
  modu.OutAct = 0: If modu.Out >= 0 Or Casc(icasc).p > modu.sH Then modu.OutAct = -1

'1 Cascade
With Casc(icasc)
'Max. number of gammas in 1 cascade
  If .ng > modu.ng Then modu.ng = .ng
  If NUCLIDE(inuc).nCascGam < .ng Then NUCLIDE(inuc).nCascGam = .ng
'Grundzerfall
  i = InStr(.Nam, "G"): If i > 1 Then sNamAnf = Left(.Nam, i - 2)
'  If i = 1 Then sNamAnf = .Nam
  If i = 1 Then sNamAnf = ""
  If sNamAnf = "" Then 'Isomer
    iAlpha = 0: ibeta = 0: iec = 0: sGrund = sNamAnf: ZG = 1: ZG2 = 1
  End If
  If Left(.Nam, 1) = "A" Then 'Alpha
    iAlpha = 1: ibeta = 0: iec = 0: sGrund = sNamAnf
  End If
  If Abs(.nB > 0) Then  'Beta
    iAlpha = 0: ibeta = Abs(.nB): iec = 0: sGrund = sNamAnf
  End If
  If .nEC > 0 Then  'EC
    iAlpha = 0: iec = .nEC: ibeta = 0: sGrund = sNamAnf: sG = " E"
  End If: sname = sGrund
  
  sG1 = sGrund & "G" & Trim(Str(.NamGF(1)))
  For i = 1 To 12: IGG(i) = .NumGF(i): Next
  sG2 = "G" & Trim(Str(.NamGF(2)))
  ng = .ng: p = .p: pNorm = p * fakNormC
  
  Call pCasc(.ng, pp(), ee(), IGG())
  
'Efficiency of the Cascade of one fm
  For ifm = 1 To QuenchDat(ikb).nfm
    Ausg = ((nBeta + nEC + ngamma) > 1) And (ifm = QuenchDat(ikb).iref)
'Beta or EC as start
    If iAlpha > 0 Then ZG = 1: ZG2 = 2
    If ibeta > 0 Then ZG = Beta(ibeta).ZB(ifm): ZG2 = Beta(ibeta).ZB2(ifm): .Unc2 = Beta(ibeta).Unc2
    If iec > 0 Then ZG = EC(iec).ZE(ifm): ZG2 = EC(iec).ZE2(ifm): .Unc2 = EC(iec).Unc2
    EffCascG = 0: uncv = .Unc2
'Efficiency of the cascade with different Number of gammas in this cascade
    Call EfCasc(.ng, pp(), ee(), IGG(), EffCasc, EffCascG)
    If iAlpha > 0 Then EffCasc = 1
    Eff_Contrib = EffCasc * pNorm
    If ifm = QuenchDat(ikb).iref Then
      sumC = sumC + Eff_Contrib
      EffDat(ikb).EffN(ifm) = sumC: .contr = Eff_Contrib: .EffRef = EffCasc
      sA = fok(icasc, 3, 0, 1) & fopk(p, 3, 2, 1)
      sA = sA & fopk(pNorm, 3, 2, 2)
      sA = sA & fos(sNamG, 12) & fopk(EffCascG, 4, 2, 2) & fopk((1 - EffCascG), 3, 2, 1)
      sA = sA & "|" & fopk(EffCasc, 3, 2, 1) & fopk(Eff_Contrib, 3, 3, 1)
      sA = sA & fopk(sumC, 3, 3, 0) & vbCrLf & sLin & vbCrLf: sCasc = sA
      If modu.OutAct And (p > modu.sH) Then O.sCasc = O.sCasc & sA
    End If
    If ifm = QuenchDat(ikb).iref2 Then
      .EffRef2 = EffCasc
    End If
    EffAct(ifm) = EffAct(ifm) + Eff_Contrib
  Next ifm: modu.C = 1
  GoTo CPEnd
End With

CPEnd:: End Sub

Public Sub pCasc(ng, pp(), ee(), IGG()) 'p of the Way
Select Case ng
  Case 0: GoSub pCasc0G
  Case 1: GoSub pCasc1G
  Case 2: GoSub pCasc2G
  Case Is > 2: GoSub pCasc2G
End Select
GoTo PCEnd

pCasc0G:     'p of the cascade with 0 gamma (e.g. pure EC)
  sNamG = NamensF(sGrund): sname = sNamG: pp(1) = 1
Return
  
pCasc1G:     'p of the cascade with 1 gamma (e.g. E-G1)
  sNamG = sG1: sNamG = NamensF(sNamG): sname = sNamG: iGG1 = IGG(1)
  at1 = Gamma(IGG(1)).aTot: pC1 = at1 / (1 + at1): IP1 = Gamma(IGG(1)).IP
  pp(1) = pC1                                                         'p Way c (GI)
  pp(2) = (1 - pC1) * IP1                                             'p Way p (GP)
  pp(3) = (1 - pC1) * (1 - IP1)                                       'p Way e (G)
  If sNamAnf = "" Then pp(3) = 0 'Isomer
Return

pCasc2G:     'p of the cascade with 2 gammas (e.g. E-G1-G2, sum=1)
  sNamG = sG1 & sG2: sNamG = NamensF(sNamG):  sname = sNamG
  iGG1 = IGG(1): iGG2 = IGG(2)
  at1 = Gamma(iGG1).aTot: pC1 = at1 / (1 + at1): IP1 = Gamma(iGG1).IP 'Gamma1
  at2 = Gamma(iGG2).aTot: pC2 = at2 / (1 + at2): IP2 = Gamma(iGG2).IP 'Gamma2
  pp(1) = pC1 * pC2                                                   'p Way cc
  pp(2) = pC1 * (1 - pC2) * IP2                                       'p Way cp
  pp(3) = pC1 * (1 - pC2) * (1 - IP2)                                 'p Way ce
  pp(4) = (1 - pC1) * IP1 * pC2                                       'p Way pc
  pp(5) = (1 - pC1) * IP1 * (1 - pC2) * IP2                           'p Way pp
  pp(6) = (1 - pC1) * IP1 * (1 - pC2) * (1 - IP2)                     'p Way pe
  pp(7) = (1 - pC1) * (1 - IP1) * pC2                                 'p Way ec
  pp(8) = (1 - pC1) * (1 - IP1) * (1 - pC2) * IP2                     'p Way ep
  pp(9) = (1 - pC1) * (1 - IP1) * (1 - pC2) * (1 - IP2)               'p Way ee
  If sNamAnf = "" Then 'Isomer
'    pp(3) = 0                     'p Way ce
'    pp(6) = 0                     'p Way pe
'    pp(7) = 0                     'p Way ec
'    pp(8) = 0                     'p Way ep
'    pp(9) = 0                     'p Way ee
  End If
Return

PCEnd: End Sub

Public Sub EfCasc(ng, pp(), ee(), IGG(), EffCasc, EffCascG)
  Dim sA  'Hilfsgrssen Eff-Way, p-Way
Select Case ng
  Case 0: GoSub EffCasc0G
  Case 1: GoSub EffCasc1G
  Case 2: GoSub EffCasc2G
  Case Is > 2: GoSub EffCasc3G
End Select
GoTo ECEnd

EffCasc0G:     'Efficiency of the cascade with 0 gamma (e.g. pure EC)
  ee(1) = 1 + ZG2 - 2 * ZG
  EffCascG = pp(1) * ee(1): EffCasc = EffCascG: unc = uncv '.EffRef = EffCasc
Return

EffCasc1G:     'Efficiency of the cascade with 1 gamma (e.g. E-G1)
  iGG1 = IGG(1)
  ZP11 = Gamma(iGG1).zP(ifm): ZP12 = Gamma(iGG1).ZP2(ifm)
  ZI11 = Gamma(iGG1).ZI(ifm): ZI12 = Gamma(iGG1).ZI2(ifm)
  EffI = 1 + ZI12 - 2 * ZI11
  EffP = 1 + ZP12 - 2 * ZP11
  ee(1) = 1 + ZG2 * ZI12 - 2 * ZG * ZI11                              'Eff Way c
  ee(2) = 1 + ZG2 * ZP12 - 2 * ZG * ZP11                              'Eff Way p
  ee(3) = 1 + ZG2 - 2 * ZG                                            'Eff Way e
  If sNamAnf = "" Then 'Isomer
    ee(1) = 1 + ZI12 - 2 * ZI11                                'Eff Way c
    ee(2) = 1 + ZP12 - 2 * ZP11                                'Eff Way p
  End If
  For iw = 1 To 3
    EffCascG = EffCascG + pp(iw) * ee(iw)
  Next: EffCasc = EffCascG
  unc = Sqr(uncv ^ 2 + Gamma(iGG1).Unc2 ^ 2)
Return

EffCasc2G:     'Efficiency of the cascade with 2 gammas (e.g. E-G1-G2)
  iGG1 = IGG(1): iGG2 = IGG(2)
  ZP11 = Gamma(iGG1).zP(ifm): ZP12 = Gamma(iGG1).ZP2(ifm)             'Gamma1
  ZI11 = Gamma(iGG1).ZI(ifm): ZI12 = Gamma(iGG1).ZI2(ifm)             'Gamma1
  ZP21 = Gamma(iGG2).zP(ifm): ZP22 = Gamma(iGG2).ZP2(ifm)             'Gamma2
  ZI21 = Gamma(iGG2).ZI(ifm): ZI22 = Gamma(iGG2).ZI2(ifm)             'Gamma2
  ee(1) = 1 + ZG2 * ZI12 * ZI22 - 2 * ZG * ZI11 * ZI21                'Eff Way cc
  ee(2) = 1 + ZG2 * ZI12 * ZP22 - 2 * ZG * ZI11 * ZP21                'Eff Way cp
  ee(3) = 1 + ZG2 * ZI12 - 2 * ZG * ZI11                              'Eff Way ce
  ee(4) = 1 + ZG2 * ZP12 * ZI22 - 2 * ZG * ZP11 * ZI21                'Eff Way pc
  ee(5) = 1 + ZG2 * ZP12 * ZP22 - 2 * ZG * ZP11 * ZP21                'Eff Way pp
  ee(6) = 1 + ZG2 * ZP12 - 2 * ZG * ZP11                              'Eff Way pe
  ee(7) = 1 + ZG2 * ZI22 - 2 * ZG * ZI21                              'Eff Way ec
  ee(8) = 1 + ZG2 * ZP22 - 2 * ZG * ZP21                              'Eff Way ep
  ee(9) = 1 + ZG2 - 2 * ZG                                            'Eff Way ee
  If sNamAnf = "" Then 'Isomer
    ee(1) = 1 + ZI12 * ZI22 - 2 * ZI11 * ZI21                  'Eff Way cc
    ee(2) = 1 + ZI12 * ZP22 - 2 * ZI11 * ZP21                  'Eff Way cp
    ee(4) = 1 + ZP12 * ZI22 - 2 * ZP11 * ZI21                  'Eff Way pc
    ee(5) = 1 + ZP12 * ZP22 - 2 * ZP11 * ZP21                  'Eff Way pp
  End If
  For iw = 1 To 9
    EffCascG = EffCascG + pp(iw) * ee(iw)
  Next
  EffCasc = EffCascG
  unc = Sqr(uncv ^ 2 + Gamma(iGG1).Unc2 ^ 2 + Gamma(iGG2).Unc2 ^ 2)
Return

EffCasc3G:     'Efficiency of the cascade with more than 2 gammas (e.g. E-G1-G2-G3-G4)
  GoSub EffCasc2G
  EffnonCasc = 1 - EffCascG
  For iG = 3 To ng
  iGG1 = IGG(1): iGG2 = IGG(2): iGG3 = IGG(iG): sNamGam = Gamma(iGG3).Name
    EffnonG = 1 - eff_g(iGG3, ifm): EffnonCasc = EffnonG * EffnonCasc
    EffCasc = 1 - EffnonCasc
    If (p > modu.sH) And Ausg Then
      sA = String(20, " ") & "G " & sfoNr(sNamGam, 4)
      sA = sA & fopk(eff_g(iGG3, ifm), 10, 2, 1) & fopk(EffnonG, 4, 2, 1) & "|"
      sB = sA & vbCrLf
      O.sCasc = O.sCasc & sB
    End If
    unc = Sqr(unc ^ 2 + Gamma(iGG3).Unc2 ^ 2)
  Next iG
Return


ECEnd: End Sub


Public Sub Iso_Main_Part()
  Static sA, sX
  ReDim Eff_Grund(QuenchDat(ikb).nfm)
  Dim pp(9), ee(9), IGG(12) 'Hilfsgrssen Eff-Way, p-Way
  Call Subs("  Iso_Main_Part " & NUCLIDE(inuc).Nuc & ": Isom" & iIs)
  modu.OutAct = 0: If modu.Out >= 0 Or Isom(iIs).p > modu.sH Then modu.OutAct = -1

'1 Cascade-Isomer
With Isom(iIs)
'Max. number of gammas in 1 cascade-isomer
  If .ng > modu.ng Then modu.ng = .ng
  If NUCLIDE(inuc).nIsomGam < .ng Then NUCLIDE(inuc).nIsomGam = .ng
'Grundzerfall
  i = InStr(.Nam, "G"): If i > 0 Then sNamAnf = Left(.Nam, i - 1) Else sNamAnf = .Nam
  If sNamAnf = "" Then 'Isomer
    iAlpha = 0: ibeta = 0: iec = 0: sGrund = sNamAnf: ZG = 1: ZG2 = 1
  End If
  If Left(.Nam, 1) = "A" Then 'Alpha
    iAlpha = 1: ibeta = 0: iec = 0: sGrund = sNamAnf
  End If
  If Abs(.nB > 0) Then  'Beta
    iAlpha = 0: ibeta = Abs(.nB): iec = 0: sGrund = sNamAnf
  End If
  If .nEC > 0 Then  'EC
    iAlpha = 0: iec = .nEC: ibeta = 0: sGrund = sNamAnf: sG = " E"
  End If: sname = sGrund
  
  sG1 = sGrund
  If .NamGF(1) > "" Then sG1 = sG1 & "G" & Trim(Str(.NamGF(1)))
  For i = 1 To 12: IGG(i) = .NumGF(i): Next
  If .NamGF(2) > "" Then sG2 = "G" & Trim(Str(.NamGF(2))) Else sG2 = ""
'    sG2 = "G" & Trim(Str(.NamGF(2)))
  ng = .ng: p = .p: pNorm = p * fakNormC
  
  Call pCasc(.ng, pp(), ee(), IGG())
  
'Efficiency of the Iso-Cascade of one fm
  For ifm = 1 To QuenchDat(ikb).nfm
    Ausg = ((nBeta + nEC + ngamma) > 1) And (ifm = QuenchDat(ikb).iref)
'Beta or EC as start
    If iAlpha > 0 Then ZG = 1: ZG2 = 2
    If ibeta > 0 Then ZG = Beta(ibeta).ZB(ifm): ZG2 = Beta(ibeta).ZB2(ifm): .Unc2 = Beta(ibeta).Unc2
    If iec > 0 Then ZG = EC(iec).ZE(ifm): ZG2 = EC(iec).ZE2(ifm): .Unc2 = EC(iec).Unc2
    EffIsomG = 0: uncv = .Unc2
    
'Efficiency of the iso-cascade with different Number of gammas in this cascade
    Call EfCasc(.ng, pp(), ee(), IGG(), EffIsom, EffIsomG)
    If iAlpha > 0 Then EffIsom = 1
    Eff_Contrib = EffIsom * pNorm
    If ifm = QuenchDat(ikb).iref Then
      sumC = sumC + Eff_Contrib
      EffDat(ikb).EffN(ifm) = sumC: .contr = Eff_Contrib: .EffRef = EffIsom
      sA = fok(iIs, 3, 0, 1) & fopk(p, 3, 2, 1)
      sA = sA & fopk(pNorm, 3, 2, 2)
      sA = sA & fos(sNamG, 12) & fopk(EffIsomG, 4, 2, 2) & fopk((1 - EffIsomG), 3, 2, 1)
      sA = sA & "|" & fopk(EffIsom, 3, 2, 1) & fopk(Eff_Contrib, 3, 3, 1)
      sA = sA & fopk(sumC, 3, 3, 0) & vbCrLf & sLin & vbCrLf: sIsom = sA
      O.sCasc = O.sCasc & sA
    End If
    If ifm = QuenchDat(ikb).iref2 Then
      .EffRef2 = EffIsom
    End If
    EffAct(ifm) = EffAct(ifm) + Eff_Contrib
  Next ifm: modu.C = 1
  GoTo IPEnd
End With

IPEnd:: End Sub

Public Sub Iso2_Main_Part()
  Static sA, sX, sNamAnf
  ReDim Eff_Grund(QuenchDat(ikb).nfm)
  Dim pp(9), ee(9) 'Hilfsgrssen Eff-Way, p-Way
Call Subs("  Iso2_Main_Part " & NUCLIDE(inuc).Nuc & ": Isom" & iIs)
'1 isomer
With Isom(iIs)
'Grundzerfall
  If Abs(.nB > 0) Then  'Beta
    ibeta = Abs(.nB): iec = 0
    sGrund = "B" & Trim(Str(ibeta))
    If .nB < 0 Then sGrund = "B" & Trim(Str(ibeta))
  End If
  If .nEC > 0 Then  'EC
    iec = .nEC: ibeta = 0
    sGrund = "E" & Trim(Str(.nEC)): sG = " E"
  End If: sname = sGrund
  Select Case .ng
    Case 0: GoSub pIsom0G
    Case 1: GoSub pIsom1G
    Case 2: GoSub pIsom2G
    Case Is > 2: GoSub pIsom2G
  End Select
  
  'Efficiency of the isomer of one fm
  For ifm = 1 To QuenchDat(ikb).nfm
    Ausg = ((nBeta + nEC + ngamma) > 1) And (ifm = QuenchDat(ikb).iref)
    ng = .ng: p = .p: pNorm = p '* fakNormI
    'Beta or EC as start
    If Isom(iIs).nB > 0 Then ZG = Beta(ibeta).ZB(ifm): ZG2 = Beta(ibeta).ZB2(ifm): .Unc2 = Beta(ibeta).Unc2
    If Isom(iIs).nEC > 0 Then ZG = EC(iec).ZE(ifm): ZG2 = EC(iec).ZE2(ifm): .Unc2 = EC(iec).Unc2
    EffIsomG = 0
    'Efficiency of the isomer with different Number of gammas in this cascade
    Select Case ng
      Case 0: GoSub EffIsom0G
      Case 1: GoSub EffIsom1G
      Case 2: GoSub EffIsom2G
      Case Is > 2: GoSub EffIsom3G
    End Select
    If iAlpha > 0 Then EffIsom = 1

    Eff_Contrib = EffIsom * pNorm
    If ifm = QuenchDat(ikb).iref Then
      sumC = sumC + Eff_Contrib
      EffDat(ikb).EffN(ifm) = sumC: .contr = Eff_Contrib: .EffRef = EffIsom
      sA = fok(iIs, 3, 0, 1) & fopk(p, 3, 2, 9)
      sA = sA & fos(sNamG, 12) & fopk(EffIsomG, 4, 2, 2) & fopk((1 - EffIsomG), 3, 2, 1)
      sA = sA & "|" & fopk(EffIsom, 3, 2, 1) & fopk(Eff_Contrib, 3, 3, 1)
      sA = sA & fopk(sumC, 3, 3, 1) & "Isomer" & vbCrLf & sLin & vbCrLf: sCasc = sA
      O.sCasc = O.sCasc & sA
    End If
    EffAct(ifm) = EffAct(ifm) + Eff_Contrib
  Next ifm: modu.C = 1
  GoTo IPEnd
'----------------------------------------------------------------------------------------
    
      
 
pIsom0G:     'p of the isomer with 0 gamma (e.g. pure EC)
    sNamG = NamensF(sGrund): sname = sNamG: pp(1) = 1
Return
  
pIsom1G:     'p of the isomer with 1 gamma (e.g. E-G1)
  iGG1 = .NumGF(1)
  sNamG = sGrund & "G" & Trim(Str(.NamGF(1))): sNamG = NamensF(sNamG): sname = sNamG
  at1 = Gamma(iGG1).aTot: pC1 = at1 / (1 + at1): IP1 = Gamma(iGG1).IP
  pp(1) = pC1                                                         'p Way c (GI)
  pp(2) = (1 - pC1) * IP1                                             'p Way p (GP)
  pp(3) = (1 - pC1) * (1 - IP1)                                       'p Way e (G)
Return

pIsom2G:     'p of the isomer with 2 gammas (e.g. E-G1-G2, sum=1)
  iGG1 = .NumGF(1): iGG2 = .NumGF(2): sNamG = NamensF(sNamG)
  sNamG = Left(sGrund & "G" & Trim(Str(.NamGF(1))) & "G" & Trim(Str(.NamGF(2))) & "      ", 9)
  sname = sNamG
  at1 = Gamma(iGG1).aTot: pC1 = at1 / (1 + at1): IP1 = Gamma(iGG1).IP 'Gamma1
  at2 = Gamma(iGG2).aTot: pC2 = at2 / (1 + at2): IP2 = Gamma(iGG2).IP 'Gamma2
  pp(1) = pC1 * pC2                                                   'p Way cc
  pp(2) = pC1 * (1 - pC2) * IP2                                       'p Way cp
  pp(3) = pC1 * (1 - pC2) * (1 - IP2)                                 'p Way ce
  pp(4) = (1 - pC1) * IP1 * pC2                                       'p Way pc
  pp(5) = (1 - pC1) * IP1 * (1 - pC2) * IP2                           'p Way pp
  pp(6) = (1 - pC1) * IP1 * (1 - pC2) * (1 - IP2)                     'p Way pe
  pp(7) = (1 - pC1) * (1 - IP1) * pC2                                 'p Way ec
  pp(8) = (1 - pC1) * (1 - IP1) * (1 - pC2) * IP2                     'p Way ep
  pp(9) = (1 - pC1) * (1 - IP1) * (1 - pC2) * (1 - IP2)               'p Way ee
Return

EffIsom0G:     'Efficiency of the isomer with 0 gamma (e.g. pure EC)
  ee(1) = 1 + ZG2 - 2 * ZG
  EffIsomG = pp(1) * ee(1): EffIsom = EffIsomG: unc = .Unc2
Return

EffIsom1G:     'Efficiency of the isomer with 1 gamma (e.g. E-G1)
  iGG1 = .NumGF(1)
  ZP11 = Gamma(iGG1).zP(ifm): ZP12 = Gamma(iGG1).ZP2(ifm)
  ZI11 = Gamma(iGG1).ZI(ifm): ZI12 = Gamma(iGG1).ZI2(ifm)
  EffI = 1 + ZI12 - 2 * ZI11
  EffP = 1 + ZP12 - 2 * ZP11
  ee(1) = 1 + ZG2 * ZI12 - 2 * ZG * ZI11                              'Eff Way c
  ee(2) = 1 + ZG2 * ZP12 - 2 * ZG * ZP11                              'Eff Way p
  ee(3) = 1 + ZG2 - 2 * ZG                                            'Eff Way e
  If (.nEC + .nB) = 0 Then ee(3) = 0
  For iw = 1 To 3
    EffIsomG = EffIsomG + pp(iw) * ee(iw)
  Next:: EffIsom = EffIsomG
  unc = Sqr(.Unc2 ^ 2 + Gamma(iGG1).Unc2 ^ 2)
Return

EffIsom2G:     'Efficiency of the isomer with 2 gammas (e.g. E-G1-G2)
  iGG1 = .NumGF(1): iGG2 = .NumGF(2)
  ZP11 = Gamma(iGG1).zP(ifm): ZP12 = Gamma(iGG1).ZP2(ifm)             'Gamma1
  ZI11 = Gamma(IGG).ZI(ifm): ZI12 = Gamma(IGG).ZI2(ifm)               'Gamma1
  ZP21 = Gamma(iGG1).zP(ifm): ZP22 = Gamma(iGG1).ZP2(ifm)             'Gamma2
  ZI21 = Gamma(IGG).ZI(ifm): ZI22 = Gamma(IGG).ZI2(ifm)               'Gamma2
  ee(1) = 1 + ZG2 * ZI12 * ZI22 - 2 * ZG * ZI11 * ZI21                'Eff Way cc
  ee(2) = 1 + ZG2 * ZI12 * ZP22 - 2 * ZG * ZI11 * ZP21                'Eff Way cp
  ee(3) = 1 + ZG2 * ZI12 - 2 * ZG * ZI11                              'Eff Way ce
  ee(4) = 1 + ZG2 * ZP12 * ZI22 - 2 * ZG * ZP11 * ZI21                'Eff Way pc
  ee(5) = 1 + ZG2 * ZP12 * ZP22 - 2 * ZG * ZP11 * ZP21                'Eff Way pp
  ee(6) = 1 + ZG2 * ZP12 - 2 * ZG * ZP11                              'Eff Way pe
  ee(7) = 1 + ZG2 * ZI22 - 2 * ZG * ZI21                              'Eff Way ec
  ee(8) = 1 + ZG2 * ZP22 - 2 * ZG * ZP21                              'Eff Way ep
  ee(9) = 1 + ZG2 - 2 * ZG                                            'Eff Way ee
  For iw = 1 To 9
    EffIsomG = EffIsomG + pp(iw) * ee(iw)
  Next:: EffIsom = EffIsomG
  unc = Sqr(.Unc2 ^ 2 + Gamma(iGG1).Unc2 ^ 2 + Gamma(IGG).Unc2 ^ 2)
Return

EffIsom3G:      'Efficiency of the isomer with more than 2 gammas (e.g. E-G1-G2-G3-G4)
  GoSub EffIsom2G
  EffnonIsom = 1 - EffIsomG
  For iG = 3 To .ng
    EffnonG = 1 - eff_g(iG, ifm): EffnonIsom = EffnonG * EffnonIsom
    EffIsom = 1 - EffnonIsom
    If Ausg Then
      sA = String(18, " ") & "G" & sfoNr(.NamGF(iG), 4)
      sA = sA & fopk(eff_g(iG, ifm), 8, 2, 1) & fopk(EffnonG, 4, 2, 1) & "|" & vbCrLf
      O.sCasc = O.sCasc & sA
    End If
    unc = Sqr(.Unc2 ^ 2 + Gamma(iG).Unc2 ^ 2)
  Next iG
Return

End With
     
IPEnd:: End Sub


Public Function NamensF(ByVal s As String)
  i = InStr(s, "G"): If i > 0 Then s = Left(s, i - 1) & " x" & Right(s, Len(s) - i)
  i = InStr(s, "G"): If i > 0 Then s = Left(s, i - 1) & " x" & Right(s, Len(s) - i)
  i = InStr(s, "x"): If i > 0 Then Mid(s, i, 1) = "G"
  i = InStr(s, "x"): If i > 0 Then Mid(s, i, 1) = "G"
  s = Left(s & "           ", 13)
  NamensF = s
End Function

