Attribute VB_Name = "Module12"
  DefSng A-H
  DefSng U-Z
  Public sA
  

Sub Gamma_Main_Part()
' ===================================================================
  ReDim Preserve nRedSpek(1000)
  LZ = vbCrLf
  Call Visib("G"): Call Subs("  Gamma_Main_Part " & NUCLIDE(inuc).Nuc & ": G" & igamma)
  If modu.Random = 1 Then
    Close 34: sFlI34 = sPfdE + "random.dat"
    Open sFlI34 For Input As #34: iGen = 0
  End If
' -------------------------------------------------------------------
'   INTERACTION
' -------------------------------------------------------------------
  With Gamma(igamma)
    EGam = .E
    Call ECStart(2): iGrundBild = 6: numP = 18: ZerfPar = 4
    strx = " G" + Str(Gamma(igamma).Name)
    If .f = 0 Then .f = 1
    IPOpt = 1: If .E > 15 Then IPOpt = 0.5
    If .E > 50 Then IPOpt = 0.2
    If .E > 500 Then IPOpt = 0.1
    nPhotPart = nPhotDat * .p * .f * 1 / (1 + .aTot) * IPOpt
    nPhotPart = (Int(nPhotPart / nPhotMin) + 1) * nPhotMin
    Call PhotonAbs(strx, EGam, nRedSpek(), pEsc)
    .IP = 1 - pEsc: nPhotGam = 0
    For i = 1 To 100
      ESpekt(3, i) = nRedSpek(i): nPhotGam = nPhotGam + nRedSpek(i)
    Next
     Call ProbaIC(pEscKL, pEscLX, pEscKX)
     Call EffEnIC
     pPh = 1 / (1 + .aTot): fakConv = (1 - pPh)
     modu.OutAct = 1 'Kurzausgabe in anderen Fllen
     If modu.Out >= 0 Then modu.OutAct = -1 'Ausgabe vollstndig bei Ausgabemodus 1 und 2
     If (ikb = 1) And (Gamma(igamma).p > modu.sH) And (fakConv > 0.0005) Then modu.OutAct = -1 'Ausgabe vollstndig bei p und Conv signifikant

  ' -------------------------------------------------------------------
  '   COUNTING EFFICIENCY
  ' -------------------------------------------------------------------
    For ifm = 1 To QuenchDat(ikb).nfm
      fm = QuenchDat(ikb).fmwert(ifm)
      If nPhotKL > 0 Then Call Quant_EC(ESpekt(), nPhotKL, nPhotKM, ZE, ZE2)  'Abfrage???
      Call Quant_IC(ESpekt(), nPhotKL, nPhotKM, EGam, EK, ZI, ZI2)
      Call Quant_Photonen(ESpekt(), nPhotGam, EGam, zP, ZP2)
      EffPh = 1! - 2 * zP + ZP2: EffIC = 1! - 2 * ZI + ZI2
      .zP(ifm) = zP: .ZP2(ifm) = ZP2: .ZI(ifm) = ZI: .ZI2(ifm) = ZI2
      fakPhot = pPh * .IP
      EffGamma = fakConv * EffIC + fakPhot * EffPh
      EffAct(ifm) = EffGamma
      eff_g(igamma, ifm) = EffGamma
      EffEC = 1! - 2 * ZE + ZE2
      EffECIC = 1! - 2 * ZE * ZI + ZE2 * ZI2
      EffECGamma = 1! - 2 * ZE * zP + ZE2 * ZP2
      pr2 = .p * (1 - .IP) * EffECGamma
      pr3 = .p * .IP * EffEC
      pr4 = .p * (1 - .IP) * EffPh
  '  Ausgabe der Werte fr einen ausgewhlten fm-Wert
      If ifm = QuenchDat(ikb).iref Then GoSub GammaEffAus
    Next ifm
    modu.G = 1:  'If (ikb = 1) And (.p > modu.sH) Then GoSub GWegeAus
  End With
GoTo GMPEnd


GammaEffAus:
  With Gamma(igamma)
    ZPRef = zP: ZP2Ref = ZP2: ZIRef = ZI: ZI2Ref = ZI2
    nv = 4: nn = 3
    If .aTot < 10 Then nv = 1: nn = 4
    If .aTot > 100 Then nv = 7: nn = 0
'    sA = fok(igamma, 2, 0, 0) & ": G" & sfoNr(.Name, 3) & " of " & NUCLIDE(inuc).Nuc
'    sA = sA & "   p=" & fopk(.p, 3, 2, 1)
'    sA = sA & "%  E=" & fok(.E, 4, 1, 1) & "keV  IP="
'    sA = sA & fopk(.IP, 3, 2, 1) & "%"
    sA = fok(igamma, 2, 0, 0) & ": G" & sfoNr(.Name, 3) & fopk(.p, 3, 2, 1)
    sA = sA & fok(.E, 4, 1, 1) & fopk(.IP, 3, 2, 3)
    If modu.OutAct Then
      
      If .aTot > 0.000001 Then
'        sA = sA & "  Alpha " & fok(.aTot, nv, nn, 2)
'        sA = sA & fok(.aK, nv, nn, 2)
'        sA = sA & fok(.aL, nv, nn, 2)
'        sA = sA & fok(.aM, nv, nn, 2)
        sA = sA & fok(.aTot, nv, nn, 2)
        sA = sA & fok(.aK, nv, nn, 2)
        sA = sA & fok(.aL, nv, nn, 2)
        sA = sA & fok(.aM, nv, nn, 2)
      Else
        sA = sA & "    - no conversion -           "
      End If
    Else
      sA = sA & " Alpha 0"
    End If: sG = sA & fopk(eff_g(igamma, ifm), 4, 2, 0): sG2 = "" 'auch fr Grid
    If modu.Out >= 0 Then
      If (.aTot > 0.001) And (.p > 0.0005) Then
        GoSub GWegeAus
        sB = sC & " Conversion  p% " & fopk(1 - pPh, 3, 2, 22) & "Eff% " & fopk(EffIC, 3, 2, 2)
        sB = sB & "Product% " & fopk(fakConv * EffIC, 3, 3, 2) & LZ
        sB = sB & " Photons     p% " & fopk(pPh, 3, 2, 2) & "Absorption% " & fopk(.IP, 3, 2, 2)
        sB = sB & "Eff% " & fopk(EffPh, 3, 2, 2)
        sG2 = sB & "Product% " & fopk(fakPhot * EffPh, 3, 3, 2)
      End If
    End If
  End With
Return

GWegeAus:
  If Gamma(igamma).aTot = 0 Then sC = "": Return
  pECSum = 0!: pICSum = 0!: pECEffEnSum = 0!: pICEffEnSum = 0!: wpeqSum = 0
  For i = 1 To 22
    pECSum = pECSum + w(i).pEC: pICSum = pICSum + w(i).pIC
    pECEffEnSum = pECEffEnSum + w(i).pEC * w(i).EffEnEC
    pICEffEnSum = pICEffEnSum + w(i).pIC * w(i).EffEnIC
    If i = 18 Then pECAugerSum = pECSum
    If i = 18 Then pICAugerSum = pICSum
    pECICEffEnSum = pECEffEnSum + pICEffEnSum
  Next i
  If pECICEffEnSum = 0 Then pECICEffEnSum = 1
  For i = 1 To 18
    b1(i) = w(i).pEC * w(i).EffEnEC / pECICEffEnSum
    b2(i) = w(i).pIC * w(i).EffEnIC / pECICEffEnSum
  Next i
  If modu.Out > 0 Then sA = " ** Details: Gamma Conversion Ways **" & LZ & sLin & LZ
  If modu.Out = 0 Then sA = " ** Details: Significant Gamma Conversion Ways (with p>1%)**" & LZ & sLin & LZ
  sA = sA & " Nr        Measured          | Escape      p%  EffEn(keV)" & LZ
  sA = sA & sLin & LZ

  For i = 1 To 22
    EQM = w(i).EffEnIC: If EQM > 10 Then EQM = 10
    If (w(i).pIC > modu.sH) And (EQM > 0) Then
      k = k + 1: wpeqSum = wpeqSum + w(i).pIC * EQM
      sA = sA & fok(i, 3, 0, 7) & w(i).path & fopk(w(i).pIC, 7, 2, 2)
      sA = sA & fok(w(i).EffEnIC, 4, 1, 1) & LZ
    End If
  Next: sA = sA & " Sum  pIC" & fopk(pICSum, 34, 2, 0)
  If Not modu.OutAct Then
    sA = " No significant gamma conversion ways, Sum  pIC" & fopk(pICSum, 2, 2, 0)
  End If
  If k = -1 Then k = 0
  If (modu.Out = 2) Then GoSub GPhotonenAus
  sC = sA & LZ
  If pICSum < modu.sH Then sC = ""
Return

GPhotonenAus:
  pKLSumM = w(19).pIC + w(20).pIC + w(21).pIC
  pKLSumE = w(7).pIC + w(8).pIC + w(9).pIC
  pKLSum = pKLSumM + pKLSumE
  pKXSumM = w(22).pIC: pKXSumE = w(14).pIC: pKXSum = w(14).pIC + w(22).pIC
  pLXSumM = w(3).pIC + w(5).pIC + 2 * w(6).pIC + w(9).pIC + w(12).pIC + w(16).pIC + w(21).pIC
  pLXSumE = w(2).pIC + 2 * w(4).pIC + w(8).pIC + w(11).pIC + w(15).pIC + w(20).pIC
  pLXSum = pLXSumM + pLXSumE
  For i = 1 To 14: p_ce_K = p_ce_K + w(i).pIC: Next
  For i = 15 To 17: p_ce_L = p_ce_L + w(i).pIC: Next
  p_ce_M = w(18).pIC
  sA = sA & sForm(6) & LZ & " Photons (p in %)" & LZ
  sA = sA & sForm(10) & LZ & "       Measured   Escape     Sum      E(keV)" & LZ
  sA = sA & " KL" & fopk(pKLSumM, 7, 2, 2) & fopk(pKLSumE, 5, 2, 2) & fopk(pKLSum, 5, 2, 2) & fok(Atom.EKL, 5, 2, 2) & LZ
  sA = sA & " KX" & fopk(pKXSumM, 7, 2, 2) & fopk(pKXSumE, 5, 2, 2) & fopk(pKXSum, 5, 2, 2) & fok(Atom.EKX, 5, 2, 2) & LZ
  sA = sA & " LX" & fopk(pLXSumM, 7, 2, 2) & fopk(pLXSumE, 5, 2, 2) & fopk(pLXSum, 5, 2, 2) & fok(Atom.ELX, 5, 2, 2) & LZ
  sA = sA & " g" & fopk(pPh, 28, 2, 0) & fok(EGam, 7, 2, 2) & LZ
Return

GMPEnd:: End Sub


Sub CrossSection(ByVal Energy, csTotSci, csPhotSci, ByVal VolSciRel, ByVal VolWatRel)
' ===========================================================================
'   CrossSection COMPUTES THE CROSS SECTION OF THE SCINTILLATOR/WATER MIXTURE
' ===========================================================================
  Dim csFunc1, f1, f2, f3
  Call Subs("    CrossSection")
  If Energy = 0 Then logEn = 0 Else logEn = Log(Energy)
  logEn2 = logEn ^ 2: logEn3 = logEn ^ 3
  For i = 1 To 8
    With CrossS(i)
      f1 = 0: f2 = 0: f3 = 0
      For ii = 1 To 4: f1 = f1 + .k(ii) * logEn ^ (ii - 1): Next
      For ii = 5 To 8: f2 = f2 + .k(ii) * logEn ^ (ii - 5): Next
      For ii = 9 To 12: f3 = f3 + .k(ii) * logEn ^ (ii - 9): Next
      .Phot = Exp(f1): .Comp = Exp(f2) + Exp(f3): .tot = .Phot + .Comp
    End With
  Next
   ProSum = 0
   For i = 1 To 8:
     ProSum = ProSum + sZ.pEl(i): CrossS(i).fak = sZ.pEl(i) / sZ.Mol(i)
   Next
   fakSci = 0.6023 * sZ.D / ProSum: fakWat = 0.6023 * 1 / 18
   csSum1 = 0: csSum2 = 0
   For i = 1 To 8:
     csSum1 = csSum1 + CrossS(i).fak * CrossS(i).Phot
     csSum2 = csSum2 + CrossS(i).fak * CrossS(i).tot
   Next
   csPhotSci = VolSciRel * fakSci * csSum1 + VolWatRel * fakWat * (2! * CrossS(1).Phot + CrossS(4).Phot)
   csTotSci = VolSciRel * fakSci * csSum2 + VolWatRel * fakWat * (2! * CrossS(1).tot + CrossS(4).tot)
   GoTo CsEnd

CsEnd:: End Sub



Sub EffEnIC()
' ===================================================================
'   EffEnIC COMPUTES THE ENERGIES FOR THE DIFFERENT WAYS OF ATOMIC
'   REARRANGEMENT DUE TO THE CONVERSION PROCESS
' ===================================================================
  Call Subs("    EffEnIC")
  EGam = Gamma(igamma).E
  EConvK = EGam - Atom.EK: If EConvK <= 0 Then EConvK = 5!
  EConvL = EGam - Atom.eL: If EConvL <= 0 Then EConvL = 5!
  EConvM = EGam - Atom.EM
  For iway = 1 To 14: w(iway).EffEnIC = w(iway).EffEnEC + EConvK * Quench(EConvK): Next
  For iway = 15 To 17: w(iway).EffEnIC = w(iway).EffEnEC + EConvL * Quench(EConvL): Next
  w(18).EffEnIC = w(18).EffEnEC + EConvM * Quench(EConvM)
  For iway = 19 To 22: w(iway).EffEnIC = 0: Next
End Sub

Sub Quant_Photonen(ESpekt(), ByVal nPhotGam, ByVal EGam, zP, ZP2)
'    COMPUTES THE GAMMA QUANTITIES
' ===================================================================
  If ifm = iref Then Call Subs("    Quant_Photonen")
  fm = QuenchDat(ikb).fmwert(ifm): fm2 = 2! * fm: zP = 0!: ZP2 = 0!: EGamInc = EGam / 100!
  For k = 1 To 100
    If ESpekt(3, k) <> 0 Then
      EGamAct = EGamInc * k
      zP = zP + ESpekt(3, k) * Exp(-EGamAct / fm2)
      ZP2 = ZP2 + ESpekt(3, k) * Exp(-EGamAct / fm)
    End If
  Next
  zP = zP / nPhotGam: ZP2 = ZP2 / nPhotGam
End Sub

Sub Quant_IC(ESpekt(), ByVal nPhotKL, ByVal nPhotKM, ByVal EGam, ByVal EK, ZI, ZI2)
' ===================================================================
  
  If ifm = iref Then Call Subs("    Quant_IC")
  fm = QuenchDat(ikb).fmwert(ifm): fm2 = 2! * fm: ZI = 0!: ZI2 = 0!
  For i = 1 To 18
    ZI = ZI + w(i).pIC * Exp(-w(i).EffEnIC / fm2)
    ZI2 = ZI2 + w(i).pIC * Exp(-w(i).EffEnIC / fm)
  Next
  sw1 = 0: sw2 = 0!: sw3 = 0!: SWP1 = 0!: SWP2 = 0!: SWP3 = 0!
  EGamInc = Atom.EKL / 100!: EConvK = EGam - EK: If EConvK <= 0 Then EConvK = 5!
  EConvKQ = EConvK * Quench(EConvK)
  For l = 1 To 100
    If ESpekt(1, l) <> 0 Then
      EN1 = Atom.ELXY * Quench(Atom.ELXY) + EGamInc * l
      EN2 = EGamInc * l
      EN3 = EGamInc * l + Atom.ELX * Quench(Atom.ELX)
      SEN1 = EN1 + EConvKQ
      SEN2 = EN2 + EConvKQ
      SEN3 = EN3 + EConvKQ
      sw1 = sw1 + ESpekt(1, l) * Exp(-SEN1 / fm2)
      sw2 = sw2 + ESpekt(1, l) * Exp(-SEN2 / fm2)
      sw3 = sw3 + ESpekt(1, l) * Exp(-SEN3 / fm2)
      SWP1 = SWP1 + ESpekt(1, l) * Exp(-SEN1 / fm)
      SWP2 = SWP2 + ESpekt(1, l) * Exp(-SEN2 / fm)
      SWP3 = SWP3 + ESpekt(1, l) * Exp(-SEN3 / fm)
    End If
  Next
  SW4 = 0!: SWP4 = 0!: EGamInc = Atom.EKX / 100
  For l = 1 To 100
    If ESpekt(2, l) <> 0 Then
      EN4 = EGamInc * l: SEN4 = EN4 + EConvKQ
      SW4 = SW4 + ESpekt(2, l) * Exp(-SEN4 / fm2)
      SWP4 = SWP4 + ESpekt(2, l) * Exp(-SEN4 / fm)
    End If
  Next
  ZI = ZI + (sw1 * w(19).pIC + sw2 * w(20).pIC + sw3 * w(21).pIC) / nPhotKL
  ZI = ZI + SW4 * w(22).pIC / nPhotKM
  ZI2 = ZI2 + (SWP1 * w(19).pIC + SWP2 * w(20).pIC + SWP3 * w(21).pIC) / nPhotKL
  ZI2 = ZI2 + SWP4 * w(22).pIC / nPhotKM
End Sub


Sub NormSpek(NY(), ByVal ener, ByVal ENI)
' ===================================================================
'   NormSpek GIVES ENERGY SPECTRUM IN 100 CHANNELS
' ===================================================================
      If ener < 0 Then ener = 0
      n = Int(ener / ENI * 100)
      NY(n) = NY(n) + 1
End Sub


Sub PhotonAbs(ByVal strx, ByVal Energy, nRedSpek(), pEsc)
'   PhotonAbs COMPUTES THE ENERGY SPECTRUM OF THE ELECTRONS PRODUCED IN
'   THE INTERACTION OF PHOTONS WITH THE SCINTILLATOR
' -------------------------------------------------------------------
'        nAbsSpek      =    ABSORTION SPECTRUM
'        nEmisSpek     =    EMISSION SPECTRUM
'        nRedSpek      =    REDUCED SPECTRUM
' ===================================================================
  Dim nAbsSpek(1000), nEmisSpek(1000)
  Dim rCoord#, hCoord#, xCoord#, yCoord#, zCoord#
  Dim uDir#, vDir#, wDir#, pLen#
  Dim csTotSci As Single, csPhotSci As Single, sum As Single, sW As Single, iPhotCh
  Call Subs("    PhotonAbs " & strx)
  For i = 1 To 100
    nRedSpek(i) = 0
  Next

  eUnterE = 0.002: EPSI = 0.01: If nPhotPart < 100 Then nPhotPart = 100
  rCoord# = rfield(1): hCoord# = rfield(2)
  VolTotal = sZ.VolSci + sZ.VolWat
  VolSciRel = sZ.VolSci / VolTotal: VolWatRel = sZ.VolWat / VolTotal
  nEsc = 0: nFot = 0: nUnterE = 0: nCompt = 0
  En = Energy: If En > 10 Then En = Format(En, "####0")
  With frmCN2
    .txtAction.Text = sAction & sAct(5)
    .txtNucl.Text = sN
    .lblNum.Caption = "of " & foSc(nPhotPart)
    .lblEnerg.Caption = RTrim(strx) & fo(Energy, 7, 0, 0) & " keV"
  End With
  Call CrossSection(Energy, csTotSci, csPhotSci, VolSciRel, VolWatRel)
  pf = csPhotSci / csTotSci
  If modu.Act Then Print #83, "Random numbers used for " & strx & "  " & Energy & "keV "
  If modu.Act Then Print #83, "CrossSection(Energy, csTotSci, csPhotSci, VolSciRel, VolWatRel)"; Energy; csTotSci; csPhotSci; VolSciRel; VolWatRel
  
  iPhotCh = 10000: If nPhotMin < 5000 Then iPhotCh = nPhotMin
  For iPhot = 1 To nPhotPart
    DoEvents: Call IconAnimation2:
    If iPhot Mod iPhotCh = 0 Then
      If modu.Calc Then With frmCN2.lblEventNr: .Caption = "MC: " & foSc(iPhot) & " phot": .Refresh: End With
      If modu.unc Then With frmCN2.lblEventNr: .Caption = "MonteCarlo: " & vbCrLf & foSc(iPhot) & " events": .Refresh: End With
      DoEvents
    End If
    nInt = 0: sum = 0!
    Call Punkt(rCoord#, hCoord#, xCoord#, yCoord#, zCoord#)
    x0# = xCoord#: y0# = yCoord#: z0# = zCoord#
    Call Richtung(uDir#, vDir#, wDir#): En = Energy
1:  Call WegLaenge(pLen#, csTotSci)
    xCoord# = x0# + uDir# * pLen#
    yCoord# = y0# + vDir# * pLen#
    zCoord# = z0# + wDir# * pLen#
    x2# = xCoord# ^ 2: y2# = yCoord# ^ 2
' -------------------------------------------------------------------
'   ESCAPES?
' -------------------------------------------------------------------
    If ((Abs(zCoord#) < (hCoord# / 2)) And (x2# + y2#) < (rCoord# ^ 2)) Then GoTo 3
    If nInt > 0 Then GoTo 4
    nEsc = nEsc + 1
    Call NormSpek(nEmisSpek(), Energy, Energy)
    GoTo 2
    
4:  ESA = Energy - En
    ESE = En
    Call NormSpek(nAbsSpek(), ESA, Energy)
    Call NormSpek(nEmisSpek(), ESE, Energy)
    Call NormSpek(nRedSpek(), sum, Energy)
    nCompt = nCompt + 1
    GoTo 2
    
' -------------------------------------------------------------------
'   PHOTOELECTRIC OR COMPTON?
' -------------------------------------------------------------------
3:  ZufZ# = RandomGen#
    If (ZufZ# > pf) Then GoTo 5
    nFot = nFot + 1: ESA = Energy: ESE = 0!
    sum = sum + En * Quench(En)
    Call NormSpek(nAbsSpek(), ESA, Energy)
    Call NormSpek(nEmisSpek(), ESE, Energy)
    Call NormSpek(nRedSpek(), sum, Energy)
    GoTo 2
    
5:  ENR = En / 511!
    UU = ENR / (1! + 0.5626 * ENR)
    ZufZ# = RandomGen#
    EDISP = ENR / (1! + UU * ZufZ# + (2! * ENR - UU) * ZufZ# ^ 3)
    EEL = (ENR - EDISP) * 511!
    sum = sum + EEL * Quench(EEL)
    If (EDISP > eUnterE) Then GoTo 6
    ESA = Energy: ESE = 0!
    Call NormSpek(nAbsSpek(), ESA, Energy)
    Call NormSpek(nEmisSpek(), ESE, Energy)
    Call NormSpek(nRedSpek(), sum, Energy)
    nUnterE = nUnterE + 1
    GoTo 2

6:  a = 1! + 1! / ENR - 1! / EDISP
    B = (1! - a * a): If B < 0 Then B = 0
    B = Sqr(B)
    ZufZ# = RandomGen#
    CMU = pi * (2! * ZufZ# - 1!)
    C = Cos(CMU)
    D = Abs(CMU) * Sqr(1! - C * C)
    If (1! - Abs(wDir)) > EPSI Then
      sW = Sqr(1! - wDir * wDir)
      u1 = (B * C * wDir * uDir - B * D * vDir) / sW + a * uDir
      V1 = (B * C * wDir * vDir + B * D * uDir) / sW + a * vDir
      W1 = -B * C * sW + a * wDir
    Else
      u1 = B * C: V1 = B * D: W1 = a * wDir
    End If
    uDir = u1: vDir = V1: wDir = W1: x0 = xCoord: y0 = yCoord: z0 = zCoord
    En = EDISP * 511!
    nInt = nInt + 1
    GoTo 1
2:
  Next iPhot
  pInteract = (nPhotPart - nEsc) / nPhotPart
  pAbs = (nPhotPart - nEsc - nCompt) / nPhotPart
  pTotAbs = nFot / nPhotPart
  pEsc = nEsc * 1! / nPhotPart
  sC = strx & fok(Energy, 5, 2, 1)
  sB = "keV IP" & fopk(pInteract, 3, 2, 1) & "%  Esc" & fopk(pEsc, 3, 2, 1)
  sB = sB & "%  tot." & fopk(pTotAbs, 3, 2, 1) & "%  nPh" & fok(nPhotPart, 7, 0, 0)
  If modu.Act Then
    If igamma > 0 Then
      Print #82, sLin
      Print #82, "GammaNr  keV: "; igamma; Energy
      Print #82, "nRedSpek(i) in PhotonAbs (von "; nPhotPart; ")"
      For i = 1 To 100
        Print #82, fo(nRedSpek(i), 5, 0, 1);
        If i Mod 10 = 0 Then Print #82, " "
      Next
    End If
  End If
  Prog = Prog + ProgressInc: frmCN2.prgProgress.Value = Prog: nProgrParts = nProgrParts + 1
'  Debug.Print Prog
End Sub



Sub ProbaIC(ByVal pEscKL, ByVal pEscLX, ByVal pEscKX)
' ===================================================================
'   PROBA COMPUTES THE PROBABILITIES FOR THE DIFFERENT WAYS OF ATOMIC
'   REARRANGEMENT DUE TO THE CONVERSION PROCESSES
' ===================================================================
      Call Subs("    ProbaIC")
      AlphaT = Gamma(igamma).aTot
      AlphaK = Gamma(igamma).aK: pCK = AlphaK / (1 + AlphaT)
      alphaL = Gamma(igamma).aL: pCL = alphaL / (1 + AlphaT)
      alphaM = Gamma(igamma).aM: pCM = alphaM / (1 + AlphaT)
      wAugerK = 1 - Atom.wK
      wAugerL = 1 - Atom.wL
      pAbsLM = 1 - pEscLX
      w(1).pIC = pCK * wAugerK * Atom.pKLL * wAugerL * wAugerL
      w(2).pIC = 2 * pCK * wAugerK * Atom.pKLL * wAugerL * Atom.wL * pEscLX
      w(3).pIC = 2 * pCK * wAugerK * Atom.pKLL * wAugerL * Atom.wL * pAbsLM
      w(4).pIC = pCK * wAugerK * Atom.pKLL * Atom.wL * Atom.wL * pEscLX ^ 2
      w(5).pIC = 2 * pCK * wAugerK * Atom.pKLL * Atom.wL * Atom.wL * pAbsLM * pEscLX
      w(6).pIC = pCK * wAugerK * Atom.pKLL * Atom.wL * Atom.wL * pAbsLM * pAbsLM
      w(7).pIC = pCK * Atom.wK * Atom.pKL * wAugerL * pEscKL
      w(8).pIC = pCK * Atom.wK * Atom.pKL * Atom.wL * pEscKL * pEscLX
      w(9).pIC = pCK * Atom.wK * Atom.pKL * Atom.wL * pAbsLM * pEscKL
      w(10).pIC = pCK * wAugerK * Atom.pKLX * wAugerL
      w(11).pIC = pCK * wAugerK * Atom.pKLX * Atom.wL * pEscLX
      w(12).pIC = pCK * wAugerK * Atom.pKLX * Atom.wL * pAbsLM
      w(13).pIC = pCK * wAugerK * Atom.pKXY
      w(14).pIC = pCK * Atom.wK * Atom.pKX * pEscKX
      w(15).pIC = pCL * Atom.wL * pEscLX
      w(16).pIC = pCL * Atom.wL * pAbsLM
      w(17).pIC = pCL * wAugerL
      w(18).pIC = pCM
      w(19).pIC = pCK * Atom.wK * Atom.pKL * wAugerL * (1 - pEscKL)
      w(20).pIC = pCK * Atom.wK * Atom.pKL * Atom.wL * (1 - pEscKL) * pEscLX
      w(21).pIC = pCK * Atom.wK * Atom.pKL * Atom.wL * (1 - pEscKL) * (1 - pEscLX)
      w(22).pIC = pCK * Atom.wK * Atom.pKX * (1 - pEscKX)
End Sub

Sub Punkt(ByVal rCoord#, hCoord#, xCoord#, yCoord#, zCoord#)
' ===================================================================
'    Punkt GENERATES A RANDOM POINT INTO THE VIAL GEOMETRY
'    and GIVES A RANDOM DIRECTION FOR THE PHOTON
' ===================================================================
      Dim RR#, fi#
      ZufZ# = RandomGen#
      RR# = rCoord# * Sqr(ZufZ#)
      ZufZ# = RandomGen#
      fi# = pi * (2! * ZufZ# - 1!)
      xCoord# = RR# * Cos(fi#)
      yCoord# = RR# * Sin(fi#)
      ZufZ# = RandomGen#
      zCoord# = hCoord# * (2! * ZufZ# - 1!) / 2!
End Sub

Sub Richtung(uDir#, vDir#, wDir#)
' ===================================================================
'   Richtung GIVES A RANDOM DIRECTION FOR THE PHOTON
' ===================================================================
      Dim R#, fi#
      ZufZ# = RandomGen#
      wDir# = 2! * ZufZ# - 1
      R# = Sqr(1! - wDir# ^ 2)
      ZufZ# = RandomGen#
      fi# = pi# * (2! * ZufZ# - 1!)
      uDir# = R# * Cos(fi#)
      vDir# = R# * Sin(fi#)
End Sub

Sub WegLaenge(pLen#, ByVal csTotSci)
' ===================================================================
'   WegLaenge COMPUTES THE PATH LENGTH FOR THE PHOTON
' ===================================================================
      Dim lambda As Single
      lambda = 1! / csTotSci
      ZufZ# = RandomGen#
      pLen# = -lambda * Log(ZufZ#)
      
End Sub


Public Sub EffEnIC2()
' ===================================================================
'   EffEnIC2 COMPUTES THE ENERGIES FOR THE 264 DIFFERENT WAYS OF ATOMIC
'   REARRANGEMENT DUE TO THE CONVERSION PROCESS
' ===================================================================
End Sub
