Attribute VB_Name = "Module2"
Option Explicit
Public sA, Wid, Hei


Public Sub VTextParts(ByVal si)
  Dim E, Q, x
  Select Case si
    Case "Sci":    'Cross sections
        sT = "   The cross sections of the scintillator " & sRep(5) & "used here are calculated with the"
        sT = sT & "  scintillator composition" & vbCrLf
        sT = sT & sRep(6)
        sT = sT & "    and the photon cross section treatment of " & sTypC & "."
    Case "RefQ":  'Ref Quench
        E = 5: ikb = 1
        sT = "  Quench Ref. value (E =" & fo(E, 1, 0, 1) & "keV, kb =" & fo(QuenchDat(1).rkB, 2, 4, 0) & ", fm = 1.2):"
        Q = Quench(E): x = (1 - Exp(-E * Q / (2 * 1.2))) ^ 2
        sT = sT & " Q(E) =" & fo(Q, 2, 5, 1) & " Eff%(Ref) =" & fop(x, 3, 3, 1) & "%"
    Case "RefCS":    'Ref Cross sections
        sT = "  Cross Section Reference value of the scintillator (total, E=100 keV): "
        Call CrossSection(100, csTotSci, csPhotSci, VolSciRel, VolWatRel)
        sT = sT & fo(csTotSci, 2, 5, 2)
    Case "X": 'EC
        sT = " a. X-rays: With the Monte Carlo subroutine PhotonAbs the interaction probabilities (IP%, symbol a) of" & vbCrLf
        sT = sT & "    photons (KL, KM and LM X-rays) with the scintillator nr." & Str(sZ.Nr) & " *** " & RTrim(LTrim(sZ.Name)) & " *** are calculated." & vbCrLf
        sT = sT & "    The program is time-optimized, the number of photons in the Monte Carlo calculation is calculated with" & vbCrLf
        sT = sT & "    the probabilities of the X-rays as parameters, but the minimum is " & nPhotMin & " photons." & vbCrLf
        sT = sT & "    Then the full energy absorption spectra (100 channels) and the Compton electron spectra (100 channels)" & vbCrLf
        sT = sT & "    are calculated." & vbCrLf
    Case "G": 'Gamma
        sT = " a. Photons: With the Monte Carlo subroutine PhotonAbs the interaction probabilities (IP%, symbol a) of" & vbCrLf
        sT = sT & "    photons (gamma rays) with the scintillator nr." & Str(sZ.Nr) & " *** " & RTrim(LTrim(sZ.Name)) & " *** are calculated." & vbCrLf
        sT = sT & "    The program is time-optimized, the number of photons in the Monte Carlo calculation is calculated with" & vbCrLf
        sT = sT & "    the probabilities of the photons as parameters, but the minimum is " & nPhotMin & " photons." & vbCrLf
        sT = sT & "    Then the full energy absorption spectra (100 channels) and the Compton electron spectra (100 channels)" & vbCrLf
        sT = sT & "    are calculated." & vbCrLf
    Case Else
  End Select
VTEnd:: End Sub


Public Sub TextParts(ByVal si, ByVal sA)
  Dim ss, ss2, sD, strW, strY, sLin4, sxx, Q, x, E: E = 5
  sLin = " " & String(135, "-"): sLin2 = " " & String(135, "=")
  sLin3 = String(70, "-"): sLin4 = String(50, " .") & vbCrLf
  ss = String(70, "-") & vbCrLf: ss2 = sLin3
  If modu.Info Then sLin = sLin & vbCrLf: ss2 = ss2 & vbCrLf
  sD = "      ": sT = ""
  If Right(si, 1) <> "*" Then si = si & "*"
  If Left(si, 1) <> "*" Then si = "*" & si
  Close 67: Open sPfdE & sA For Input As #67
  Do While Not EOF(67)
    Line Input #67, sT
    If InStr(Left(sT, 5), si) > 0 Then Exit Do
  Loop
  sT = ""
  Do While Not EOF(67)
    Line Input #67, sxx:
    If Left(sxx, 1) = "*" Then Exit Do
    sT = sT & sxx & vbCrLf
  Loop
  
  GoTo TEnd
TEnd:: End Sub

Public Sub TextScreen(ByVal si)
  Close 67: Open sPfdE & "InfHelp.txt" For Input As #67
  si = Trim(si):
  If Val(si) < 22 Then Call TextParts(si, "GenInf.txt")
  If Val(si) > 22 Then Call TextParts(si, "InfHelp.txt")
  frmCN3.fraInfo.Visible = True
  With frmCN3.txtEd1
'    .Width = MaxTxtWidth: .Height = MaxTxtHeight * 3 / 4: .Top = MaxHeight / 4
'    Select Case icfg
'      Case 1: .FontSize = 6 '640*480
'      Case 2: .FontSize = 8 '800*600
'      Case 3: .FontSize = 11 '1024*768
'    End Select
    .Text = sT:
  End With
   
End Sub

