Attribute VB_Name = "Module11"
  DefSng A-H

  Public pEC!(30)
  Public xFeld!(100), y!(100), ys!(100), E!(30), b1!(30), b2!(30)
  Public EffEC, nRedSpek(), ZufZ#
  Public nPhotPart, nPhotPartKL, nPhotPartKM, nPhotPartLM, nPhotDat
  
  
Sub EC_Main_Part(ByVal ModEC)
' ===================================================================
  ReDim Preserve nRedSpek(1000)
  Dim x As Single, sA
  Randomize Timer: iGrundBild = 4: Call Visib("E")
  Call ECStart(1): Call Subs("  EC_Main_Part " & NUCLIDE(inuc).Nuc & ": E" & iec)
  numP = 18: LZ = vbCrLf
' -------------------------------------------------------------------
' ENERGY SPECTRA PRODUCED BY THE MOST ENERGETIC PHOTONS
' ESpekt(1, i) = KL - PHOTONEN
' ESpekt(2, i) = KX - PHOTONEN
' -------------------------------------------------------------------
  Select Case ModEC
  Case Is < 1:
      If ModEC < 1 Then  '0/-1: EC-Rechnung, Interaction probabilities werden berechnet
        IPOpt = 1: If Atom.EKX > 15 Then IPOpt = 0.5
    'KL Photons
        If modu.Random = 1 Then
           Close 34: sFlI34 = sPfdE + "random.dat"
           Open sFlI34 For Input As #34: iGen = 0
        End If
        nPhotPart = nPhotDat * Atom.pKL * EC(iec).p * Atom.wK * IPOpt * SumECP
        nPhotPart = (Int(nPhotPart / nPhotMin) + 1) * nPhotMin: nPhotPartKL = nPhotPart
        If (iec = 1) Then
          Call PhotonAbs(" KL", Atom.EKL, nRedSpek(), pEscKL): sPhot = sC & sB
          nPhotKL = 0
          For i = 1 To 100
            ESpekt(1, i) = nRedSpek(i)
            nPhotKL = nPhotKL + nRedSpek(i)
          Next: ESpekt(1, 0) = nPhotKL
        End If
    'LX Photons
        If modu.Random = 1 Then
           Close 34: sFlI34 = sPfdE + "random.dat"
           Open sFlI34 For Input As #34: iGen = 0
        End If
        x = (1 - Exp(-Atom.ELX * Quench(Atom.ELX) / (2 * QuenchDat(ikb).fmRef))) ^ 2
        nPhotPart = nPhotDat * EC(iec).p * Atom.wL * x * SumECP
        nPhotPart = (Int(nPhotPart / nPhotMin) + 1) * nPhotMin: nPhotPartLM = nPhotPart
        If (iec = 1) Then
          Call PhotonAbs(" LX", Atom.ELX, nRedSpek(), pEscLX)
          sPhot = sPhot & LZ & sC & sB
          For i = 1 To 100
            ESpekt(0, i) = nRedSpek(i)
            nPhotLM = nPhotLM + nRedSpek(i)
          Next: ESpekt(0, 0) = nPhotLM
        End If
    'KX Photons
        If modu.Random = 1 Then
           Close 34: sFlI34 = sPfdE + "random.dat"
           Open sFlI34 For Input As #34: iGen = 0
        End If
        nPhotPart = nPhotDat * Atom.pKX * EC(iec).p * Atom.wK * IPOpt * SumECP
        nPhotPart = (Int(nPhotPart / nPhotMin) + 1) * nPhotMin: nPhotPartKM = nPhotPart
       If (iec = 1) Then
          Call PhotonAbs(" KX", Atom.EKX, nRedSpek(), pEscKX)
          
          sPhot = sPhot & LZ & sC & sB
          nPhotKM = 0
          For i = 1 To 100
            ESpekt(2, i) = nRedSpek(i)
            ESpekt(3, i) = 0
            nPhotKM = nPhotKM + nRedSpek(i)
          Next: ESpekt(2, 0) = nPhotKM
        End If
        If modu.Calc Then If Not frmCN1.opMod2.Value Then Call Ausgabe("EC-Phot")
      End If
        Atom.ESpekt(1, 0) = nPhotKL: Atom.ESpekt(2, 0) = nPhotKM
        Atom.pEscKL = pEscKL: Atom.pEscKX = pEscKX: Atom.pEscLX = pEscLX
        For j = 1 To 3
          For i = 1 To 100
             Atom.ESpekt(j, i) = ESpekt(j, i)
          Next
        Next
  Case Is = 1:
        nPhotKL = Atom.ESpekt(1, 0): nPhotKM = Atom.ESpekt(2, 0)
        pEscKL = Atom.pEscKL: pEscKX = Atom.pEscKX: pEscLX = Atom.pEscLX
        For j = 1 To 3
          For i = 1 To 100
            ESpekt(j, i) = Atom.ESpekt(j, i)
          Next
        Next
  End Select
  Call ProbaEC(pEscKL, pEscKX, pEscLX)
  Call EffEnEC
  If nEC = 0 Then GoTo ECPEnd
'- - - - - - ab hier nur bei EC - - - - - - - - - - - - - - - - - -
'------------
'Spektrum
'------------
For i = 1 To 22
  With w(i)
    For iE = 1 To 400
      If (10 ^ (iE / 50) > .EffEnEC) Then Exit For
    Next iE
    NUCLIDE(inuc).xSp(1, iE) = NUCLIDE(inuc).xSp(1, iE) + .pEC * 10 ^ (iE / 50)
  End With
Next

'  With NUCLIDE(inuc)
'    EAkt = EMax
'    If inuc > 0 Then
'      For iE = 0 To 200
'        EVar = 10 ^ (iE / 50)
'        wp# = EVar / 511 + 1
'        Call FermiWert(ZNuc, AMNuc, EAkt, iShape, wp#, Fermi#)
'        .xSp(0, iE) = EVar
'        .xSp(1, iE) = .xSp(1, iE) + Beta(ibeta).p * Fermi# * (EVar - EVarV)
'        EVarV = EVar
'        Print #9, fo(EVar, 4, 2, 2);
'        Print #9, fo(Fermi#, 2, 4, 0)
'      Next
'    End If
'  End With

Call Ausgabe("EC-2")
If (ikb = 1) And (EC(iec).p > modu.sH) Then GoSub ECWegeAus
'If modu.Out > 1 Then GoSub ECPhotonenAus
Call Visib("E2")
  For ifm = 1 To QuenchDat(ikb).nfm
    fm = QuenchDat(ikb).fmwert(ifm)
    Call Quant_EC(ESpekt(), nPhotKL, nPhotKM, ZE, ZE2)
    eff_ec(iec, ifm) = 1! - 2 * ZE + ZE2
    EffAct(ifm) = eff_ec(iec, ifm)
    If (ifm = QuenchDat(ikb).iref) Then
      ZERef = ZE: ZE2Ref = ZE2: EC(iec).EffRef = EffAct(ifm)
      If (iec = 1) And (modu.Out = -1) Then
        sA = "     IP(KL)" & fopk(1 - pEscKL, 3, 1, 1) & "%"
        sA = sA & "IP(KM)" & fopk(1 - pEscKX, 3, 1, 1) & "%"
        sA = sA & "IP(LM)" & fopk(1 - pEscLX, 3, 1, 1) & "%"
      End If
        sA = "ZE" & fok(ZERef, 2, 4, 1) & "ZE2" & fok(ZE2Ref, 2, 4, 8)
        sA = sA & "-->    Part.Eff_EC" & fopk(eff_ec(iec, QuenchDat(ikb).iref), 3, 2, 0)
        sA = sA & "% (fm=" & fo(QuenchDat(ikb).fmRef, 1, 2, 0) & ")" & LZ & LZ
        If modu.Calc Then O.sEC = O.sEC & sForm(10) & sA: If ikb = 1 Then Call Grid(13)
    End If
    EC(iec).ZE(ifm) = ZE: EC(iec).ZE2(ifm) = ZE2
  Next
GoTo ECPEnd

PhotoOptimierung:
  IPOpt = 1: If Gamma(igamma).E > 15 Then IPOpt = 0.5
  If Gamma(igamma).E > 50 Then IPOpt = 0.2
  If Gamma(igamma).E > 500 Then IPOpt = 0.1
  nPhotPart = nPhotDat * Gamma(igamma).p * 1 / (1 + Gamma(igamma).aTot)
  nPhotPart = nPhotPart * IPOpt
  nPhotoPart = (Int(nPhotoPart / 500) + 1) * 500
Return

ECWegeAus:
  If (modu.Out < 0) Or ((iec <> iecMax) And (modu.Out < 2)) Then Return
  pKLSumM = w(19).pEC + w(20).pEC + w(21).pEC 'X-Rays
  pKLSumE = w(7).pEC + w(8).pEC + w(9).pEC
  pKLSum = pKLSumM + pKLSumE
  pKXSumM = w(22).pEC: pKXSumE = w(14).pEC: pKXSum = w(14).pEC + w(22).pEC
  pLXSumM = w(3).pEC + w(5).pEC + 2 * w(6).pEC + w(9).pEC + w(12).pEC + w(16).pEC + w(21).pEC
  pLXSumE = w(2).pEC + 2 * w(4).pEC + w(8).pEC + w(11).pEC + w(15).pEC + w(20).pEC
  pLXSum = pLXSumM + pLXSumE
  pXSumM = pKLSumM + pKXSumM + pLXSumM
  pXSumE = pKLSumE + pKXSumE + pLXSumE
  sx1 = LZ & " Photons (p in %)":
  sx2 = "       Measured   Escape     Sum      E(keV)" & LZ
  sx2 = sx2 & " KL" & fopk(pKLSumM, 7, 2, 2) & fopk(pKLSumE, 5, 2, 2) & fopk(pKLSum, 5, 2, 2) & fok(Atom.EKL, 5, 2, 2) & LZ
  sx2 = sx2 & " KX" & fopk(pKXSumM, 7, 2, 2) & fopk(pKXSumE, 5, 2, 2) & fopk(pKXSum, 5, 2, 2) & fok(Atom.EKX, 5, 2, 2) & LZ
  sx2 = sx2 & " LX" & fopk(pLXSumM, 7, 2, 2) & fopk(pLXSumE, 5, 2, 2) & fopk(pLXSum, 5, 2, 2) & fok(Atom.ELX, 5, 2, 2) & LZ

  pECSum = 0!: pECEffEnSum = 0!: pECAugerSum = 0!: sB = LZ 'Auger + all ways
  For i = 1 To 22
    pECSum = pECSum + w(i).pEC: pECEffEnSum = pECEffEnSum + w(i).pEC * w(i).EffEnEC
    If i = 18 Then pECAugerSum = pECSum
    b1(i) = w(i).pEC * w(i).EffEnEC
  Next

  If modu.Out > 0 Then sA = " ** EC Ways **" & LZ
  If modu.Out = 0 Then sA = " ** Significant EC Ways (with p>1%) **" & LZ
  sA = sA & sLin & LZ
  sA = sA & " Nr Caption  Measured         | Escape     p%     EffEn(keV)" & LZ
  sA = sA & sLin & LZ
  k = -1
  For i = 1 To 22
    If ((w(i).pEC > modu.sH) And (w(i).EffEnEC > 0)) Or modu.Out = 2 Then
      k = k + 1
      sA = sA & fok(i, 3, 0, 2) & w(i).path & fopk(w(i).pEC, 7, 2, 5) & fok(w(i).EffEnEC, 3, 2, 2) & LZ
    End If
  Next
  sA = sA & " Sum  pEC%" & fopk(pECSum, 34, 2, 0) & LZ
  sA = sA & " Sum  pEC%(only Auger el.)" & fopk(pECAugerSum, 18, 2, 0) & LZ
  sB = sA & " Sum  pEC*EffEnEC" & fok(pECEffEnSum, 38, 3, 0)
  O.sEC = O.sEC & sForm(10) & LZ & sB & LZ
  If (modu.Out < 2) Or (iec <> iecMax) Then
    sA = " Sum  pEC%(only with X-rays)" & fopk(pXSumM, 16, 2, 0) & LZ
    sA = sA & " Sum  total escape" & fopk(pXSumE, 26, 2, 0)
    O.sEC = O.sEC & sA & LZ
  Else
    O.sEC = O.sEC & sForm(6) & LZ & sx1 & LZ
    O.sEC = O.sEC & sForm(10) & LZ & sx2 & LZ
  End If
Return

ECPhotonenAus:
  pKLSumM = w(19).pEC + w(20).pEC + w(21).pEC
  pKLSumE = w(7).pEC + w(8).pEC + w(9).pEC
  pKLSum = pKLSumM + pKLSumE
  pKXSumM = w(22).pEC: pKXSumE = w(14).pEC: pKXSum = w(14).pEC + w(22).pEC
  pLXSumM = w(3).pEC + w(5).pEC + 2 * w(6).pEC + w(9).pEC + w(12).pEC + w(16).pEC + w(21).pEC
  pLXSumE = w(2).pEC + 2 * w(4).pEC + w(8).pEC + w(11).pEC + w(15).pEC + w(20).pEC
  pLXSum = pLXSumM + pLXSumE
  pXSumM = pKLSumM + pKXSumM + pLXSumM
  pXSumE = pKLSumE + pKXSumE + pLXSumE
  sA = LZ & " EC Photons (p in %)": O.sEC = O.sEC & LZ & sForm(6) '& LZ & sA
  sA = "       Measured   Escape     Sum      E(keV)" & LZ
  sA = sA & " KL" & fopk(pKLSumM, 7, 2, 2) & fopk(pKLSumE, 5, 2, 2) & fopk(pKLSum, 5, 2, 2) & fok(Atom.EKL, 5, 2, 2) & LZ
  sA = sA & " KX" & fopk(pKXSumM, 7, 2, 2) & fopk(pKXSumE, 5, 2, 2) & fopk(pKXSum, 5, 2, 2) & fok(Atom.EKX, 5, 2, 2) & LZ
  sA = sA & " LX" & fopk(pLXSumM, 7, 2, 2) & fopk(pLXSumE, 5, 2, 2) & fopk(pLXSum, 5, 2, 2) & fok(Atom.ELX, 5, 2, 2) & LZ
  If modu.Out = 2 Then O.sEC = O.sEC & LZ & sForm(6) & LZ & sx1 & LZ & sForm(10) & LZ & sA & LZ
Return
ECPEnd: Call Visib("E2"): End Sub


Public Sub ECStart(ByVal M)
  w(1).path = "KLL+2LMM   + ce_K | -    "
  w(2).path = "KLL+LMM    + ce_K | LM   "
  w(3).path = "KLL+LMM+LM + ce_K | -    "
  w(4).path = "KLL        + ce_K | 2LM  "
  w(5).path = "KLL+LM     + ce_K | LM   "
  w(6).path = "KLL+2LM    + ce_K | -    "
  w(7).path = "LMM        + ce_K | KL   "
  w(8).path = "-          + ce_K | KL LM"
  w(9).path = "LM         + ce_K | KL   "
  w(10).path = "KLM+LMM    + ce_K | -    "
  w(11).path = "KLM        + ce_K | LM   "
  w(12).path = "KLM+LM     + ce_K | -    "
  w(13).path = "KMM        + ce_K | -    "
  w(14).path = "-          + ce_K | KM   "
  w(15).path = "-          + ce_L | LM   "
  w(16).path = "LM         + ce_L | -    "
  w(17).path = "LMM        + ce_L | -    "
  w(18).path = "-          + ce_M | -    "
  w(19).path = "KL+LMM     + ce_K | -    "
  w(20).path = "KL         + ce_K | LM   "
  w(21).path = "KL+LM      + ce_K | -    "
  w(22).path = "KM         + ce_K | -    "
  If M = 1 Then
    Dim si
    For i = 1 To 22
      If i < 18 Then si = "  K    " Else si = "  L    "
'      w(i).path = si + Left(w(i).path, 11) & "      " & Right(w(i).path, 7)
      sP = w(i).path
      w(i).path = "  " & Mid(sP, 17, 1) & "    " & Left(sP, 11) & "      " & Right(sP, 7)
    Next: modu.EC = 1
  End If
  q = Quench(5): 'Recalc. of reference quench value
  sB = "Recalculation (in ECStart)" & vbCrLf
  sB = sB & " KB=" & fo(QuenchDat(ikb).rkB, 1, 4, 0) & ": E=5 keV  Q=" & fo(q, 1, 5, 1)
  sB = sB & "TypQ=" & fo(iTypQ, 1, 0, 3) & "constants" & fo(QuenchDat(ikb).Cl(0), 2, 5, 1) & "..." & vbCrLf
  iPict = 0
  If M = 1 Then
    filePict(0) = sPfdE & "woman24.wmf" 'EC
    filePict(1) = sPfdE & "woman26.wmf"
  Else
    filePict(0) = sPfdE & "woman21.wmf" 'Gamma
    filePict(1) = sPfdE & "woman23.wmf"
  End If

End Sub

Sub EffEnEC()
'===================================================================
'   EffEnEC COMPUTES THE ENERGIES FOR THE DIFFERENT WAYS OF ATOMIC
'   REARRANGEMENT DUE TO THE CAPTURE PROCESS
' ===================================================================
      Call Subs("    EffEnEC")
      EKLL = Atom.EKLL: EKLM = Atom.EKLX: EKMM = Atom.EKXY
      ELMM = Atom.ELXY
      EKL = Atom.EKL: EKM = Atom.EKX: ELM = Atom.ELX
      EKLLQ = EKLL * Quench(EKLL): EKLMQ = EKLM * Quench(EKLM)
      EKMMQ = EKMM * Quench(EKMM): ELMMQ = ELMM * Quench(ELMM)
      EKLQ = EKL * Quench(EKL): EKMQ = EKM * Quench(EKM)
      ELMQ = ELM * Quench(ELM)
      w(1).EffEnEC = EKLLQ + 2 * ELMMQ
      w(2).EffEnEC = EKLLQ + ELMMQ
      w(3).EffEnEC = EKLLQ + ELMMQ + ELMQ
      w(4).EffEnEC = EKLLQ
      w(5).EffEnEC = EKLLQ + ELMQ
      w(6).EffEnEC = EKLLQ + 2 * ELMQ
      w(7).EffEnEC = ELMMQ
      w(8).EffEnEC = 0!
      w(9).EffEnEC = ELMQ
      w(10).EffEnEC = EKLMQ + ELMMQ
      w(11).EffEnEC = EKLMQ
      w(12).EffEnEC = EKLMQ + ELMQ
      w(13).EffEnEC = EKMMQ
      w(14).EffEnEC = 0!
      w(15).EffEnEC = 0!
      w(16).EffEnEC = ELMQ
      w(17).EffEnEC = ELMMQ
      w(18).EffEnEC = 0!
      w(19).EffEnEC = EKLQ + ELMMQ
      w(20).EffEnEC = EKLQ
      w(21).EffEnEC = EKLQ + ELMQ
      w(22).EffEnEC = EKMQ
End Sub


Sub ProbaEC(ByVal pEscKL, ByVal pEscKX, ByVal pEscLX)
' ===================================================================
'   PROBA COMPUTES THE PROBABILITIES FOR THE DIFFERENT WAYS OF ATOMIC
'   REARRANGEMENT DUE TO THE CAPTURE PROCESSES
' ===================================================================
      Call Subs("    ProbaEC")
      pK = EC(iec).pK
      pL = EC(iec).pL: pM = EC(iec).pM
      wka = 1 - Atom.wK
      wla = 1 - Atom.wL
      pEscLMa = 1 - pEscLX
      w(1).pEC = pK * wka * Atom.pKLL * wla * wla
      w(2).pEC = 2 * pK * wka * Atom.pKLL * wla * Atom.wL * pEscLX
      w(3).pEC = 2 * pK * wka * Atom.pKLL * wla * Atom.wL * pEscLMa
      w(4).pEC = pK * wka * Atom.pKLL * Atom.wL * Atom.wL * pEscLX * pEscLX
      w(5).pEC = 2 * pK * wka * Atom.pKLL * Atom.wL * Atom.wL * pEscLMa * pEscLX
      w(6).pEC = pK * wka * Atom.pKLL * Atom.wL * Atom.wL * pEscLMa * pEscLMa
      w(7).pEC = pK * Atom.wK * Atom.pKL * wla * pEscKL
      w(8).pEC = pK * Atom.wK * Atom.pKL * Atom.wL * pEscKL * pEscLX
      w(9).pEC = pK * Atom.wK * Atom.pKL * Atom.wL * pEscLMa * pEscKL
      w(10).pEC = pK * wka * Atom.pKLX * wla
      w(11).pEC = pK * wka * Atom.pKLX * Atom.wL * pEscLX
      w(12).pEC = pK * wka * Atom.pKLX * Atom.wL * pEscLMa
      w(13).pEC = pK * wka * Atom.pKXY
      w(14).pEC = pK * Atom.wK * Atom.pKX * pEscKX
      w(15).pEC = pL * Atom.wL * pEscLX
      w(16).pEC = pL * Atom.wL * pEscLMa
      w(17).pEC = pL * wla
      w(18).pEC = pM
      w(19).pEC = pK * Atom.wK * Atom.pKL * wla * (1 - pEscKL)
      w(20).pEC = pK * Atom.wK * Atom.pKL * Atom.wL * (1 - pEscKL) * pEscLX
      w(21).pEC = pK * Atom.wK * Atom.pKL * Atom.wL * (1 - pEscKL) * (1 - pEscLX)
      w(22).pEC = pK * Atom.wK * Atom.pKX * (1 - pEscKX)
      WSum = 0: For i = 1 To 22: WSum = WSum + w(i).pEC: Next: w(23).pEC = WSum
End Sub


Sub Quant_EC(ESpekt(), ByVal nPhotKL, ByVal nPhotKM, ZE, ZE2)
'    COMPUTES THE EC QUANTITIES
' ===================================================================
  If ifm = iref Then Call Subs("    Quant_EC")
  fm = QuenchDat(ikb).fmwert(ifm): fm2 = 2 * fm: ZE = 0!: ZE2 = 0!
  For i = 1 To 18
    ZI = w(i).pEC * Exp(-w(i).EffEnEC / fm2)
    ZI2 = w(i).pEC * Exp(-w(i).EffEnEC / fm):
    ZE = ZE + ZI
    ZE2 = ZE2 + ZI2
  Next
  Dim ZR, ZR1: ZR = ZE: ZR2 = ZE2
  W1 = 0!: W2 = 0!: W3 = 0!: WP1 = 0!
  WP2 = 0!: WP3 = 0!: EGamInc = Atom.EKL / 100!
  For l = 1 To 100
    If ESpekt(1, l) <> 0 Then
      EN1 = Atom.ELXY * Quench(Atom.ELXY) + EGamInc * l
      EN2 = EGamInc * l
      EN3 = EGamInc * l + Atom.ELX * Quench(Atom.ELX)
      W1 = W1 + ESpekt(1, l) * Exp(-EN1 / fm2)
      W2 = W2 + ESpekt(1, l) * Exp(-EN2 / fm2)
      W3 = W3 + ESpekt(1, l) * Exp(-EN3 / fm2)
      WP1 = WP1 + ESpekt(1, l) * Exp(-EN1 / fm)
      WP2 = WP2 + ESpekt(1, l) * Exp(-EN2 / fm)
      WP3 = WP3 + ESpekt(1, l) * Exp(-EN3 / fm)
    End If
  Next
  W4 = 0!: WP4 = 0!: EGamInc = Atom.EKX / 100
  For l = 1 To 100
    If ESpekt(2, l) <> 0 Then
      EN4 = EGamInc * l
      W4 = W4 + ESpekt(2, l) * Exp(-EN4 / fm2)
      WP4 = WP4 + ESpekt(2, l) * Exp(-EN4 / fm)
    End If
  Next
  ZE = ZE + (W1 * w(19).pEC + W2 * w(20).pEC + W3 * w(21).pEC) / nPhotKL
  ZE = ZE + W4 * w(22).pEC / nPhotKM
  ZE2 = ZE2 + (WP1 * w(19).pEC + WP2 * w(20).pEC + WP3 * w(21).pEC) / nPhotKL
  ZE2 = ZE2 + WP4 * w(22).pEC / nPhotKM
  eff_ec(iec, ifm) = 1# - 2 * ZE + ZE2
  If eff_ec(iec, ifm) < 0 Then
    eff_ec(iec, ifm) = 0: ZE = 1: ZE2 = 1
  End If
  If fm = QuenchDat(ikb).fmRef Then GoSub QuECCheck
  GoTo QECEnd
  
QuECCheck:
  If (modu.Act) And (iec = 1) Then
    Print #82, String(50, "-"): Print #82, "iNuc  iEC"; inuc; iec
    Print #82, "Quant_EC: kB,iref"; QuenchDat(ikb).KB; QuenchDat(ikb).fmRef
    Print #82, "Eff"; fop(1! - 2 * ZE + ZE2, 3, 2, 1)
    Print #82, "Auger"; fo(ZR, 2, 4, 1); fo(ZR2, 2, 4, 1); "-->"; fop(1! - 2 * ZR + ZR2, 3, 2, 1)
    Print #82, "X (W,  )"; fo(W1, 5, 2, 1); fo(W2, 5, 2, 1); fo(W3, 5, 2, 1); fo(W4, 5, 2, 1)
    Print #82, "X ( ,WP)"; fo(WP1, 5, 2, 1); fo(WP2, 5, 2, 1); fo(WP3, 5, 2, 1); fo(WP4, 5, 2, 1)
    Print #82, "KL: ESpekt(1,..) von "; nPhotPartKL
    For i = 1 To 100
      Print #82, fo(ESpekt(1, i), 5, 0, 1);
      If i Mod 10 = 0 Then Print #82, " "
    Next
    Print #82, "KM: ESpekt(2,..) von "; nPhotPartKM
    For i = 1 To 100
      Print #82, fo(ESpekt(2, i), 5, 0, 1);
      If i Mod 10 = 0 Then Print #82, " "
    Next
    Print #82, "LM: ESpekt(0,..) von "; nPhotPartLM
    For i = 1 To 100
      Print #82, fo(ESpekt(0, i), 5, 0, 1);
      If i Mod 10 = 0 Then Print #82, " "
    Next
  End If
Return
QECEnd:: End Sub


Private Sub PrintSpek(sA, Spek())
Print #66, sA
For i = 0 To 9
    sA = i & "  "
    For j = 1 To 10
        sA = sA & fok(Spek(i * 10 + j), 6, 0, 1)
    Next
    Print #66, sA: sA = ""
Next


End Sub

Public Sub Proba2EC(pEscKL, pEscKX, pEscLX)
' ===================================================================
'   PROBA COMPUTES THE PROBABILITIES FOR THE 264 DIFFERENT PATHWAYS OF
'   ATOMIC REARRANGEMENT DUE TO THE CAPTURE PROCESSES
' ===================================================================


End Sub

Public Sub EffEnEC2()
'===================================================================
'   EffEnEC COMPUTES THE ENERGIES FOR THE 264 DIFFERENT WAYS OF ATOMIC
'   REARRANGEMENT DUE TO THE CAPTURE PROCESS
' ===================================================================


End Sub

Public Sub ECStart2(M)
  w(1).path = "Aug KMM"
  w(2).path = "Aug L1MM"
  w(3).path = "Aug L2MM"
  w(4).path = "Aug L3MM"
  w(5).path = "-"
  w(6).path = "X L1M"
  w(7).path = "-"
  w(8).path = "X L2M"
  w(9).path = "-"
  w(10).path = "X L3M"
  w(11).path = "-"
  w(12).path = "Aug KL1M + Aug L1MM"
  w(13).path = "Aug KL2M + Aug L2MM"
  w(14).path = "Aug KL3M + Aug L3MM"
  w(15).path = "Aug L2MM + CK L1L2M"
  w(16).path = "Aug L3MM + CK L1L3M"
  w(17).path = "Aug L3MM + CK L2L3M"
  w(18).path = "Aug KL1M + X L1M"
  w(19).path = "Aug KL1M"
  w(20).path = "Aug KL2M + X L2M"
  w(21).path = "Aug KL2M"
  w(22).path = "Aug KL3M + X L3M"
  w(23).path = "Aug KL3M"
  w(24).path = "Aug L2MM"
  w(25).path = "Aug L3MM"
  w(26).path = "CK L1L2M + X L2M"
  w(27).path = "CK L1L2M"
  w(28).path = "CK L1L3M + X L3M"
  w(29).path = "CK L1L3M"
  w(30).path = "CK L2L3M + X L3M"
  w(31).path = "CK L2L3M"
  w(32).path = "Aug KL1L1 + 2 Aug L1MM"
  w(33).path = "Aug KL1L2 + Aug L1MM + Aug L2MM"
  w(34).path = "Aug KL1L3 + Aug L1MM + Aug L3MM"
  w(35).path = "Aug KL2L2 + 2 Aug L2MM"
  w(36).path = "Aug KL2L3 + Aug L2MM + Aug L3MM"
  w(37).path = "Aug KL3L3 + 2 Aug L3MM"
  w(38).path = "Aug KL1M + Aug L2MM + CK L1L2M"
  w(39).path = "Aug KL1M + Aug L3MM + CK L1L3M"
  w(40).path = "Aug KL2M + Aug L3MM + CK L2L3M"
  w(41).path = "X L2M"
  w(42).path = "-"
  w(43).path = "X L3M"
  w(44).path = "-"
  w(45).path = "Aug L3MM + CK L1L2M + CK L2L3M"
  w(46).path = "Aug KL1L1 + Aug L1MM + X L1M"
  w(47).path = "Aug KL1L1 + Aug L1MM"
  w(48).path = "Aug KL1L2 + Aug L1MM + X L2M"
  w(49).path = "Aug KL1L2 + Aug L1MM"
  w(50).path = "Aug KL1L2 + Aug L2MM + X L1M"
  w(51).path = "Aug KL1L2 + Aug L2MM"
  w(52).path = "Aug KL1L3 + Aug L1MM + X L3M"
  w(53).path = "Aug KL1L3 + Aug L1MM"
  w(54).path = "Aug KL1L3 + Aug L3MM + X L1M"
  w(55).path = "Aug KL1L3 + Aug L3MM"
  w(56).path = "Aug KL2L2 + Aug L2MM + X L2M"
  w(57).path = "Aug KL2L2 + Aug L2MM"
  w(58).path = "Aug KL2L3 + Aug L2MM + X L3M"
  w(59).path = "Aug KL2L3 + Aug L2MM"
  w(60).path = "Aug KL2L3 + Aug L3MM + X L2M"
  w(61).path = "Aug KL2L3 + Aug L3MM"
  w(62).path = "Aug KL3L3 + Aug L3MM + X L3M"
  w(63).path = "Aug KL3L3 + Aug L3MM"
  w(64).path = "Aug KL1M + CK L1L2M + X L2M"
  w(65).path = "Aug KL1M + CK L1L2M"
  w(66).path = "Aug KL1M + CK L1L3M + X L3M"
  w(67).path = "Aug KL1M + CK L1L3M"
  w(68).path = "Aug KL2M + CK L2L3M + X L3M"
  w(69).path = "Aug KL2M + CK L2L3M"
  w(70).path = "Aug L3MM + CK L2L3M"
  w(71).path = "CK L1L2M + CK L2L3M + X L3M"
  w(72).path = "CK L1L2M + CK L2L3M"
  w(73).path = "Aug KL1L1 + Aug L1MM + Aug L2MM + CK L1L2M"
  w(74).path = "Aug KL1L1 + Aug L1MM + Aug L3MM + CK L1L3M"
  w(75).path = "Aug KL1L1 + X L1M"
  w(76).path = "Aug KL1L1 + X L1M"
  w(77).path = "Aug KL1L1"
  w(78).path = "Aug KL1L2 + 2 Aug L2MM + CK L1L2M"
  w(79).path = "Aug KL1L2 + Aug L2MM + Aug L3MM + CK L1L3M"
  w(80).path = "Aug KL1L2 + Aug L1MM + Aug L3MM + CK L2L3M"
  w(81).path = "Aug KL1L2 + 2 X L1M + X L2M"
  w(82).path = "Aug KL1L2 + 2 X L1M"
  w(83).path = "Aug KL1L2 + X L2M"
  w(84).path = "Aug KL1L2"
  w(85).path = "Aug KL1L3 + Aug L2MM + Aug L3MM + CK L1L2M"
  w(86).path = "Aug KL1L3 + 2 Aug L3MM + CK L1L3M"
  w(87).path = "Aug KL1L3 + X L1M + X L3M"
  w(88).path = "Aug KL1L3 + X L1M"
  w(89).path = "Aug KL1L3 + X L3M"
  w(90).path = "Aug KL1L3"
  w(91).path = "Aug KL2L2 + Aug L2MM + Aug L3MM + CK L2L3M"
  w(92).path = "Aug KL2L2 + X L2M"
  w(93).path = "Aug KL2L2 + X L2M"
  w(94).path = "Aug KL2L2"
  w(95).path = "Aug KL2L3 + 2 Aug L3MM + CK L2L3M"
  w(96).path = "Aug KL2L3 + 2 X L2M + X L3M"
  w(97).path = "Aug KL2L3 + 2 X L2M"
  w(98).path = "Aug KL2L3 + X L3M"
  w(99).path = "Aug KL2L3"
  w(100).path = "Aug KL3L3 + X L3M"
  w(101).path = "Aug KL3L3 + X L3M"
  w(102).path = "Aug KL3L3"
  w(103).path = "Aug KL1M + Aug L3MM + CK L1L2M + CK L2L3M"
  w(104).path = "CK L2L3M + 2 X L3M"
  w(105).path = "CK L2L3M"
  w(106).path = "Aug KL1L1 + Aug L1MM + CK L1L2M + X L2M"
  w(107).path = "Aug KL1L1 + Aug L1MM + CK L1L2M"
  w(108).path = "Aug KL1L1 + Aug L2MM + CK L1L2M + X L1M"
  w(109).path = "Aug KL1L1 + Aug L2MM + CK L1L2M"
  w(110).path = "Aug KL1L1 + Aug L1MM + CK L1L3M + X L3M"
  w(111).path = "Aug KL1L1 + Aug L1MM + CK L1L3M"
  w(112).path = "Aug KL1L1 + Aug L3MM + CK L1L3M + X L1M"
  w(113).path = "Aug KL1L1 + Aug L3MM + CK L1L3M"
  w(114).path = "Aug KL1L2 + Aug L2MM + CK L1L2M + X L2M"
  w(115).path = "Aug KL1L2 + Aug L2MM + CK L1L2M"
  w(116).path = "Aug KL1L2 + Aug L2MM + CK L1L3M + X L3M"
  w(117).path = "Aug KL1L2 + Aug L2MM + CK L1L3M"
  w(118).path = "Aug KL1L2 + Aug L3MM + CK L1L3M + X L2M"
  w(119).path = "Aug KL1L2 + Aug L3MM + CK L1L3M"
  w(120).path = "Aug KL1L2 + Aug L1MM + CK L2L3M + X L3M"
  w(121).path = "Aug KL1L2 + Aug L1MM + CK L2L3M"
  w(122).path = "Aug KL1L2 + Aug L3MM + CK L2L3M + X L1M"
  w(123).path = "Aug KL1L2 + Aug L3MM + CK L2L3M"
  w(124).path = "Aug KL1L3 + Aug L3MM + CK L1L2M + X L2M"
  w(125).path = "Aug KL1L3 + Aug L3MM + CK L1L2M"
  w(126).path = "Aug KL1L3 + Aug L2MM + CK L1L2M + X L3M"
  w(127).path = "Aug KL1L3 + Aug L2MM + CK L1L2M"
  w(128).path = "Aug KL1L3 + Aug L3MM + CK L1L3M + X L3M"
  w(129).path = "Aug KL1L3 + Aug L3MM + CK L1L3M"
  w(130).path = "Aug KL2L2 + Aug L2MM + CK L2L3M + X L3M"
  w(131).path = "Aug KL2L2 + Aug L2MM + CK L2L3M"
  w(132).path = "Aug KL2L2 + Aug L3MM + CK L2L3M + X L2M"
  w(133).path = "Aug KL2L2 + Aug L3MM + CK L2L3M"
  w(134).path = "Aug KL2L3 + Aug L3MM + CK L2L3M + X L3M"
  w(135).path = "Aug KL2L3 + Aug L3MM + CK L2L3M"
  w(136).path = "Aug KL1M + CK L1L2M + CK L2L3M + X L3M"
  w(137).path = "Aug KL1M + CK L1L2M + CK L2L3M"
  w(138).path = "Aug KL1L1 + 2 Aug L2MM + 2 CK L1L2M"
  w(139).path = "Aug KL1L1 + Aug L2MM + Aug L3MM + CK L1LM + CK L1L3M"
  w(140).path = "Aug KL1L1 + Aug L1MM + Aug L3MM + CK L1L2M + CK L2L3M"
  w(141).path = "Aug KL1L1 + CK L1L2M + X L1M + X L2M"
  w(142).path = "Aug KL1L1 + CK L1L2M + X L1M"
  w(143).path = "Aug KL1L1 + CK L1L2M + X L2M"
  w(144).path = "Aug KL1L1 + CK L1L2M"
  w(145).path = "Aug KL1L1 + 2 Aug L3MM + 2 CK L1L3M"
  w(146).path = "Aug KL1L1 + CK L1L3M + X L1M + X L3M"
  w(147).path = "Aug KL1L1 + CK L1L3M + X L1M"
  w(148).path = "Aug KL1L1 + CK L1L3M + X L3M"
  w(149).path = "Aug KL1L1 + CK L1L3M"
  w(150).path = "Aug KL1L2 + Aug L2MM + Aug L3MM + CK L1L2M + CK L2L3M"
  w(151).path = "Aug KL1L2 + CK L1L2M + X L2M"
  w(152).path = "Aug KL1L2 + CK L1L2M + X L2M"
  w(153).path = "Aug KL1L2 + CK L1L2M"
  w(154).path = "Aug KL1L2 + 2 Aug L3MM + CK L1L3M + CK L2L3M"
  w(155).path = "Aug KL1L2 + CK L1L3M + 2 X L2M + X L3M"
  w(156).path = "Aug KL1L2 + CK L1L3M + 2 X L2M"
  w(157).path = "Aug KL1L2 + CK L1L3M + X L3M"
  w(158).path = "Aug KL1L2 + CK L1L3M"
  w(159).path = "Aug KL1L2 + CK L2L3M + X L1M + X L3M"
  w(160).path = "Aug KL1L2 + CK L2L3M + X L1M"
  w(161).path = "Aug KL1L2 + CK L2L3M + X L3M"
  w(162).path = "Aug KL1L2 + CK L2L3M"
  w(163).path = "Aug KL1L3 + 2 Aug L3MM + CK L1L2M + CK L2L3M"
  w(164).path = "Aug KL1L3 + CK L1L2M + X L2M + X L3M"
  w(165).path = "Aug KL1L3 + CK L1L2M + X L3M"
  w(166).path = "Aug KL1L3 + CK L1L2M + X L2M"
  w(167).path = "Aug KL1L3 + CK L1L2M"
  w(168).path = "Aug KL1L3 + CK L1L3M + X L3M"
  w(169).path = "Aug KL1L3 + CK L1L3M + X L3M"
  w(170).path = "Aug KL1L3 + CK L1L3M"
  w(171).path = "Aug KL2L2 + 2 Aug L3MM + 2 CK L2L3M"
  w(172).path = "Aug KL2L2 + CK L2L3M + X L2M + 2 X L3M"
  w(173).path = "Aug KL2L2 + CK L2L3M + X L2M"
  w(174).path = "Aug KL2L2 + CK L2L3M + X L3M"
  w(175).path = "Aug KL2L2 + CK L2L3M"
  w(176).path = "Aug KL2L3 + 2 CK L2L3M + X L3M"
  w(177).path = "Aug KL2L3 + CK L2L3M + X L3M"
  w(178).path = "Aug KL2L3 + CK L2L3M"
  w(179).path = "Aug KL1L1 + Aug L2MM + 2 CK L1L2M + X L2M"
  w(180).path = "Aug KL1L1 + Aug L2MM + 2 CK L1L2M"
  w(181).path = "Aug KL1L1 + Aug L2MM + CK L1L2M + CK L1L3M + 2 X L3M"
  w(182).path = "Aug KL1L1 + Aug L2MM + CK L1L2M + CK L1L3M"
  w(183).path = "Aug KL1L1 + Aug L3MM + CK L1L2M + CK L1L3M + X L2M"
  w(184).path = "Aug KL1L1 + Aug L3MM + CK L1L2M + CK L1L3M"
  w(185).path = "Aug KL1L1 + Aug L1MM + CK L1L2M + CK L2L3M + X L3M"
  w(186).path = "Aug KL1L1 + Aug L1MM + CK L1L2M + CK L2L3M"
  w(187).path = "Aug KL1L1 + Aug L3MM + CK L1L2M + CK L2L3M + X L1M"
  w(188).path = "Aug KL1L1 + Aug L3MM + CK L1L2M + CK L2L3M"
  w(189).path = "Aug KL1L1 + Aug L3MM + 2 CK L1L3M + X L3M"
  w(190).path = "Aug KL1L1 + Aug L3MM + 2 CK L1L3M"
  w(191).path = "Aug KL1L2 + Aug L2MM + CK L1L2M + CK L2L3M + X L3M"
  w(192).path = "Aug KL1L2 + Aug L2MM + CK L1L2M + CK L2L3M"
  w(193).path = "Aug KL1L2 + Aug L3MM + CK L1L2M + CK L2L3M + X L2M"
  w(194).path = "Aug KL1L2 + Aug L3MM + CK L1L2M + CK L2L3M"
  w(195).path = "Aug KL1L2 + Aug L3MM + CK L1L3M + CK L2L3M + X L3M"
  w(196).path = "Aug KL1L2 + Aug L3MM + CK L1L3M + CK L2L3M"
  w(197).path = "Aug KL1L3 + Aug L3MM + CK L1L2M + CK L2L3M + X L3M"
  w(198).path = "Aug KL1L3 + Aug L3MM + CK L1L2M + CK L2L3M"
  w(199).path = "Aug KL2L2 + Aug L3MM + CK L2L3M + X L3M"
  w(200).path = "Aug KL2L2 + Aug L3MM + 2 CK L2L3M"
  w(201).path = "Aug KL1L1 + Aug L2MM + Aug L3MM + 2 CK L1L2M + CK L2L3M"
  w(202).path = "Aug KL1L1 + 2 CK L1L2M + X L2M"
  w(203).path = "Aug KL1L1 + 2 CK L1L2M + X L2M"
  w(204).path = "Aug KL1L1 + 2 CK L1L2M"
  w(205).path = "Aug KL1L1 + 2 Aug L3MM + CK L1L2M + CK L1L3M + CK L2L3M"
  w(206).path = "Aug KL1L1 + CK L1L2M + CK L1L3M + 2 X L2M + X L3M"
  w(207).path = "Aug KL1L1 + CK L1L2M + CK L1L3M + 2 X L2M"
  w(208).path = "Aug KL1L1 + CK L1L2M + CK L1L3M + X L3M"
  w(209).path = "Aug KL1L1 + CK L1L2M + CK L1L3M"
  w(210).path = "Aug KL1L1 + CK L1L2M + CK L2L3M + X L1M + X L3M"
  w(211).path = "Aug KL1L1 + CK L1L2M + CK L2L3M + X L1M"
  w(212).path = "Aug KL1L1 + CK L1L2M + CK L2L3M + X L3M"
  w(213).path = "Aug KL1L1 + CK L1L2M + CK L2L3M"
  w(214).path = "Aug KL1L1 + 2 CK L1L3M + X L3M"
  w(215).path = "Aug KL1L1 + 2 CK L1L3M + X L3M"
  w(216).path = "Aug KL1L1 + 2 CK L1L3M"
  w(217).path = "Aug KL1L2 + 2 Aug L3MM + CK L1L2M + 2 CK L2L3M"
  w(218).path = "Aug KL1L2 + CK L1L2M + CK L2L3M + X L2M + 2 X L3M"
  w(219).path = "Aug KL1L2 + CK L1L2M + CK L2L3M + X L2M"
  w(220).path = "Aug KL1L2 + CK L1L2M + CK L2L3M + X L3M"
  w(221).path = "Aug KL1L2 + CK L1L2M + CK L2L3M"
  w(222).path = "Aug KL1L2 + CK L1L3M + 2 CK L2L3M + X L3M"
  w(223).path = "Aug KL1L2 + CK L1L3M + CK L2L3M + X L3M"
  w(224).path = "Aug KL1L2 + CK L1L3M + CK L2L3M"
  w(225).path = "Aug KL1L3 + CK L1L2M + 2 CK L2L3M + 2 X L3M"
  w(226).path = "Aug KL1L3 + CK L1L2M + CK L2L3M + X L3M"
  w(227).path = "Aug KL1L3 + CK L1L2M + CK L2L3M"
  w(228).path = "Aug KL2L2 + 2 CK L2L3M + 2 X L3M"
  w(229).path = "Aug KL2L2 + CK L2L3M + X L3M"
  w(230).path = "Aug KL2L2 + 2 CK L2L3M"
  w(231).path = "Aug KL1L1 + Aug L2MM + 2 CK L1L2M + CK L2L3M + 2 X L3M"
  w(232).path = "Aug KL1L1 + Aug L2MM + 2 CK L1L2M + CK L2L3M"
  w(233).path = "Aug KL1L1 + Aug L3MM + 2 CK L1L2M + CK L2L3M + X L2M"
  w(234).path = "Aug KL1L1 + Aug L3MM + 2 CK L1L2M + CK L2L3M"
  w(235).path = "Aug KL1L1 + Aug L3MM + CK L1L2M + CK L1L3M + CK L2L3M"
  w(236).path = "Aug KL1L1 + Aug L3MM + CK L1L2M + CK L1L3M + CK L2L3M"
  w(237).path = "Aug KL1L2 + Aug L3MM + CK L1L2M + CK L2L3M + X L3M"
  w(238).path = "Aug KL1L2 + Aug L3MM + CK L1L2M + 2 CK L2L3M"
  w(239).path = "Aug KL1L1 + 2 Aug L3MM + 2 CK L1L2M + 2 CK L2L3M"
  w(240).path = "Aug KL1L1 + 2 CK L1L2M + CK L2L3M + X L2M + X L3M"
  w(241).path = "Aug KL1L1 + 2 CK L1L2M + CK L2L3M + X L2M"
  w(242).path = "Aug KL1L1 + 2 CK L1L2M + CK L2L3M + X L3M"
  w(243).path = "Aug KL1L1 + 2 CK L1L2M + CK L2L3M"
  w(244).path = "Aug KL1L1 + CK L1L2M + CK L1L3M + 2 CK L2L3M + X L3M"
  w(245).path = "Aug KL1L1 + CK L1L2M + CK L1L3M + CK L2L3M + X L3M"
  w(246).path = "Aug KL1L1 + CK L1L2M + CK L1L3M + CK L2L3M"
  w(247).path = "Aug KL1L2 + CK L1L2M + 2 CK L2L3M + 2 X L3M"
  w(248).path = "Aug KL1L2 + CK L1L2M + CK L2L3M + X L3M"
  w(249).path = "Aug KL1L2 + CK L1L2M + 2 CK L2L3M"
  w(250).path = "Aug KL1L1 + Aug L3MM + 2 CK L1L2M + CK L2L3M + 2 X L3M"
  w(251).path = "Aug KL1L1 + Aug L3MM + 2 CK L1L2M + 2 CK L2L3M"
  w(252).path = "Aug KL1L1 + 2 CK L1L2M + 2 CK L2L3M + X L3M"
  w(253).path = "Aug KL1L1 + 2 CK L1L2M + CK L2L3M + X L3M"
  w(254).path = "Aug KL1L1 + 2 CK L1L2M + 2 CK L2L3M"
  w(255).path = "-"
  w(256).path = "X KM"
  w(257).path = "Aug L2MM + X KL2"
  w(258).path = "Aug L3MM + X KL3"
  w(259).path = "X KL2 + X L2M"
  w(260).path = "X KL2"
  w(261).path = "X KL3 + 2 X L3M"
  w(262).path = "X KL3"
  w(263).path = "Aug L3MM + CK L2L3M + X KL2"
  w(264).path = "CK L2L3M + X KL2 + X L3M"
  w(265).path = "CK L2L3M + X KL2"
'  If m = 1 Then
'    For i = 1 To 265
'      Mid(w(i).path, 12, 6) = "      "
'      Mid(w(i).path, 12, 6) = ""
'    Next: modu.EC = 1
'  End If

End Sub
