Attribute VB_Name = "Module3"
Option Explicit
DefStr S
DefInt I-N
DefSng A-H
DefSng T-Z
Public si, sxlFile, sxlSheet
Public xlAnw As Excel.Application, xlBuch As Excel.Workbook, xlBlatt As Excel.Worksheet
Public xlNucBuch As Excel.Workbook, xlNucBlatt As Excel.Worksheet
Public wAnw As Word.Application, KopfBereich As Range, TextBereich As Range, Bereich As Range
Public sR, sX, sCh, sChx, sChy, sA


Public Sub ExcelChartE()
  Dim ii, xx, yy, nEff, sT As Variant, sX As Variant, sY As Variant, ch As Object
  Call Subs("    ExcelChartE " & NUCLIDE(inuc).Nuc)
  Call PlotPreparation
  ii = inuc: sT = "Tabelle" & Trim(ii): nEff = 30
  sR = "A1:" & Trim(Chr(ikb + 64)) & "33"
  xlAnw.Visible = True
'Fllen Einzelzellen
  With ActiveSheet  'xlBlatt 'Excel.Worksheets(sN)
    .Activate
    .Range("A6:K100").NumberFormat = "##0.00"
    .Range("A2:K2").NumberFormat = "##0.0"
    Cells(1, 1).Value = "Nuclide"
    Cells(1, 2).Value = "Date"
    Cells(1, 3).Value = "xMin"
    Cells(1, 4).Value = "xMax"
    Cells(1, 5).Value = "xInc"
    Cells(1, 6).Value = "yMin"
    Cells(1, 7).Value = "yMax"
    Cells(1, 8).Value = "yInc"
    Cells(2, 1).Value = sN
    Cells(2, 2).Value = Format(Now, "dd.mm.yyyy")
    Cells(2, 3).Value = Plot.xa
    Cells(2, 4).Value = Plot.xe
    Cells(2, 5).Value = Plot.gx
    Cells(2, 6).Value = Plot.ya
    Cells(2, 7).Value = Plot.ye
    Cells(2, 8).Value = Plot.gy
    Cells(6, 1).Value = "EffT%"
'Fllen Wertetabelle
    For ikb = 1 To nKB
      Cells(6, ikb + 1).Value = "kB" & QuenchDat(ikb).KB
      sR = Trim(Chr(ikb + 65))
      For i = 0 To nEff
        xx = Plot.xa + i * (Plot.xe - Plot.xa) / nEff
        yy = fnPol(xx)
        sX = "A" & Trim(Str((i + 7))): sY = sR & Trim(Str((i + 7)))
        Cells(i + 7, 1).Value = xx
        Cells(i + 7, 1 + ikb).Value = yy
      Next i
    Next ikb
 'Formatieren der Kopfzellen
    With .Range("A1:H2").Font
        .Name = "Times New Roman"
        .Size = 9
    End With
    .Range("A2:B2").Font.FontStyle = "Fett"
 'Formatieren der Wertetabelle
    With .Range("A6:Z100")
      With .Font
          .Name = "Arial"
          .FontStyle = "Fett"
          .Size = 9
      End With
    End With
'  Selektieren der Zellen fr den Plot
    sR = "A6:" & Trim(Chr(ikb + 64)) & Trim(Str(nEff + 7))
    .Range(sR).Select
  End With
  Call ChartE
End Sub

Public Sub ExcelOpen(xlOpen As Integer, sEXCELD)
  Dim Filename As String, sD
  Call Subs("    ExcelOpen")
  Set xlAnw = CreateObject("Excel.Application")
  sD = Dir(sPfdA & "Output.xls")
  If sD > "" Then Kill sPfdA & sD
  Workbooks.Open sPfdE & "Mask.xls"
  xlAnw.Visible = True
End Sub

Public Sub ExcelClose()
  ActiveWorkbook.SaveAs sPfdA & "Output.xls"
  ActiveWorkbook.Close
  With frmCN2.grdTab3
    .Row = 1: .Col = 1: sT = "Output.xls"
    If .Text > "" Then .Text = .Text & vbCrLf & sT Else .Text = sT
  End With
  
End Sub

Public Sub ExcelSheetNuc()
Dim ish, i, idel
  Set xlBlatt = Workbooks(1).Worksheets.Add
  With Workbooks(1)
    ish = .Worksheets.Count
    For i = 1 To ish
      If .Worksheets(i).Name = sN Then idel = 1
    Next
    If idel > 0 Then .Sheets(sN).Delete
    .Worksheets(1).Activate
  End With
  ActiveSheet.Name = sN
End Sub

Public Sub ChartE()
  With ActiveSheet
    .Activate
'Diagramm erstellen
    .ChartObjects.Add(350, 120, 325, 260).Select
     ActiveChart.ChartWizard Source:=Range(sR), _
     Gallery:=xlXYScatter, Format:=6, PlotBy:=xlColumns, _
     CategoryLabels:=1, SeriesLabels:=1, _
     HasLegend:=2, Title:="", CategoryTitle:="", ValueTitle:= _
     "", ExtraTitle:=""
    With ActiveChart
'Ohne Titel, mit Achstitel
    .HasTitle = False
    .Axes(xlCategory, xlPrimary).HasTitle = True
    .Axes(xlCategory, xlPrimary).AxisTitle.Characters.Text = "EffH3"
    With .Axes(xlCategory).AxisTitle
      With .Characters(Start:=1, Length:=3).Font
          .Name = "Arial"
          .FontStyle = "Fett Kursiv"
          .Size = 12
      End With
      With .Characters(Start:=4, Length:=2).Font
          .Name = "Arial"
          .FontStyle = "Fett Kursiv"
          .Size = 12
          .Subscript = True
      End With
    End With
    .Axes(xlValue, xlPrimary).HasTitle = True
    .Axes(xlValue, xlPrimary).AxisTitle.Characters.Text = "EffNuc"
    With .Axes(xlValue).AxisTitle
      .AutoScaleFont = False
      With .Characters(Start:=1, Length:=3).Font
            .Name = "Arial"
            .FontStyle = "Fett Kursiv"
            .Size = 12
            .Subscript = False
      End With
      With .Characters(Start:=4, Length:=3).Font
            .Name = "Arial"
            .FontStyle = "Fett Kursiv"
            .Size = 12
            .Subscript = True
      End With
      .AutoScaleFont = False
    End With
'Hintergrundfarbe
      .PlotArea.Border.LineStyle = xlNone
      With .PlotArea.Interior
          .ColorIndex = 19
          .PatternColorIndex = 1
          .Pattern = xlSolid
      End With
'x-Achse
'------------
'Zahlenformat, Linienstrke, Skalierung und Gitter
      With .Axes(xlCategory)
          .MajorTickMark = xlNone
          .MinorTickMark = xlNone
          .TickLabels.NumberFormat = "0"
          .HasMajorGridlines = True
          .MinimumScale = Plot.xa
          .MaximumScale = Plot.xe
          .MajorUnit = Plot.gx
          .Border.Weight = 3
          .Border.LineStyle = 1
      End With
      With .Axes(xlCategory).TickLabels.Font
          .Name = "Arial"
          .FontStyle = "Fett"
          .Size = 10
      End With
      With .Axes(xlCategory).MajorGridlines.Border
          .ColorIndex = 3
          .Weight = xlHairline
          .LineStyle = xlContinuous
      End With
'y-Achse
'------------
'Zahlenformat, Linienstrke, Skalierung und Gitter
      With .Axes(xlValue)
          .MajorTickMark = xlNone
          .MinorTickMark = xlNone
          .TickLabels.NumberFormat = "0"
          .MinimumScale = Plot.ya
          .MaximumScale = Plot.ye
          .MinorUnitIsAuto = True
          .MajorUnit = Plot.gy
          .Border.Weight = xlMedium
          .HasMajorGridlines = True
          .HasMinorGridlines = False
'      End With
        With .TickLabels
          If Plot.gy < 1 Then .NumberFormat = "0.0"
          With .Font
              .Name = "Arial"
              .FontStyle = "Fett"
              .Size = 10
          End With
        End With
        With .MajorGridlines.Border
            .ColorIndex = 3
            .Weight = xlHairline
            .LineStyle = xlContinuous
        End With
      End With
    End With
 End With

End Sub

Public Sub ExcelChartD()
  Dim xr
  Call Subs("    ExcelChartD " & NUCLIDE(inuc).Nuc)
  Const xlEdgeBottom = -4107
  xlAnw.Visible = True
  With ActiveSheet
    .Activate
    .Range("A1:Z100").ColumnWidth = 6.5
    .Range("A1:Z100").HorizontalAlignment = xlCenter
    .Range("3:5").NumberFormat = "##0.00"
'Fllen Einzelzellen
    Cells(4, 1).Value = "Decay"
    Cells(5, 1).Value = "Measurement"
'Fllen Wertetabelle
    For i = 1 To Cxls.n
      xr = 0: Cells(3, i + 1).Value = Cxls.w(i)
      Cells(4, i + 1).Value = Cxls.p(i) * 100
      Cells(5, i + 1).Value = Cxls.C(i) * 100
    Next i
    If Cxls.p(0) > 0 Then
      xr = 1: Cells(3, i + 1).Value = Cxls.w(0)
      Cells(4, i + 1).Value = Cxls.p(0) * 100
      Cells(5, i + 1).Value = Cxls.C(0) * 100
    End If
'Formatieren der Wertetabelle
    sR = "3:5"
    .Range(sR).Select
    With .Range(sR)
      With .Font
        .Name = "Arial"
        .FontStyle = "Fett"
        .Size = 6
      End With
    End With
'Unterstreichungen
    With .Rows("2:2").Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlThin
    End With
    With .Rows("5:5").Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlThin
    End With
  End With
  sR = "A3:" & Trim(Chr(Cxls.n + 65 + xr)) & "5"
  Call ChartD
End Sub

'************************************************
'  Sub LayoutAnsicht
'  switche to Layout view
'************************************************
Public Sub LayoutAnsicht()
  With wdAnw.ActiveWindow
    If .View.SplitSpecial = wdPaneNone Then   'Layoutansicht
        .ActivePane.View.Type = wdPageView
    Else
        .View.Type = wdPageView
    End If
  End With
End Sub

Public Sub ChartD()
  Dim xlLocationAsObject
  Const xlColumnStacked = 52
  With ActiveSheet
    .Activate
  End With
'Diagramm erstellen
  ActiveSheet.ChartObjects.Add(10, 120, 325, 260).Select
  With ActiveChart
    .ChartType = xlColumnStacked
    .SetSourceData Source:=Sheets(sN).Range(sR), PlotBy:=xlColumns
    .HasTitle = True
    With .ChartTitle
      .Characters.Text = sN
      .AutoScaleFont = True
      With .Font
          .Name = "Arial"
          .FontStyle = "Fett"
          .Size = 12
      End With
    End With
'Zeichenflche
    .PlotArea.Border.LineStyle = xlNone
    .PlotArea.Interior.ColorIndex = xlNone
'x-Achse
    With .Axes(xlCategory)
      .TickLabels.AutoScaleFont = True
      With .TickLabels.Font
          .Name = "Arial"
          .FontStyle = "Fett"
          .Size = 10
      End With
      With .Border
        .ColorIndex = 57
        .Weight = xlMedium
      End With
    End With
'y-Achse
    With ActiveChart.Axes(xlValue)
      .Border.ColorIndex = 57
      .Border.Weight = xlMedium
      .Border.LineStyle = xlContinuous
      .MinimumScale = 0
      .MaximumScale = 100
      .MajorUnit = 20
      With .TickLabels
          .Font.Name = "Arial"
          .Font.FontStyle = "Fett"
          .Font.Size = 10
          .NumberFormat = "0"
          
      End With
      With .MajorGridlines.Border
        .ColorIndex = 57
        .Weight = xlHairline
        .LineStyle = xlDot
      End With
    End With
    With .Legend
        .AutoScaleFont = True
        .Border.Weight = xlHairline
        .Border.LineStyle = xlNone
      With .Font
          .Name = "Arial"
          .FontStyle = "Standard"
          .Size = 8
      End With
    End With
  End With
End Sub


'************************************************
'   Public Sub LineSeparator(sB, sF)
'   separates in the report the header of sB from the text
'   and writes them for WORD output/report
'   ----- del
'   Header      sU
'   ----- del
'
'   Text        sTe
'   Format      sF, e.g. sForm(10)
'Form of the string sB before: sLin+CR - HeaderLine+CR - sLin+CR - Text (min 1 line)
'Form of the string sU after: HeaderLine+CR
'Form of the string sTe after: Text
'************************************************
Public Sub LineSeparator(ByVal sB, ByVal sF)
' Der Text sB muss mit vbCrLf enden
  Dim sU, sTe
  sU = sB: sTe = sB: modu.Free = False
  Call LineDelete(sU, 2, 100): sU = sU: Call LineDelete(sU, 1, 1)
  O.sRem = O.sRem & sForm(1) & sU & vbCrLf
  Call LineDelete(sTe, 1, 4)
  O.sRem = O.sRem & sF & sTe & vbCrLf
  modu.Free = True
WT2End:: End Sub


'************************************************
'   Public Sub LineDelete(sB, iA, iE)
'   deletes iE lines from sB, starting with line iA
'************************************************
Public Sub LineDelete(sB, ByVal iA, ByVal iE)
  Dim nCR, sBl, lB, nnCR(100) As Integer
'Suche nach allen CR$ = Zeilenanzahl
  If Len(sB) > 3 Then
    sT = sB: lB = Len(sB)
    For i = 1 To lB
      If Mid(sB, i, 2) = vbCrLf Then nCR = nCR + 1: nnCR(nCR) = i
    Next: nnCR(100) = nnCR(nCR)
  'Zeilen entfernen
    sBl = Left(sB, nnCR(iA) - 1): If iA = 1 Then sBl = ""
    If iE < 100 Then sB = sBl & Right(sB, lB - nnCR(iE)) Else sB = sBl
  End If
End Sub

'************************************************
'   Public Sub OfficeQuestion
'   gives information, if word or excel is open
'************************************************
Public Sub OfficeQuestion(ByRef wOpen As Integer, ByRef xlOpen As Integer)
  sMsg = sMsg & "OfficeQuestion  "
  Select Case getVersion()
  Case 1 'Windows 95/98
     Dim f As Long, sname As String, hSnap As Long, proc As PROCESSENTRY32
     hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
     If hSnap = hNull Then Exit Sub
     proc.dwSize = Len(proc)
     ' Iterate through the processes
     f = Process32First(hSnap, proc)
     Do While f
       sname = StrZToStr(proc.szExeFile)
       If InStr(sname, "WINWORD.EXE") > 0 Then wOpen = -1
       If InStr(sname, "EXCEL.EXE") > 0 Then xlOpen = -1
       f = Process32Next(hSnap, proc)
     Loop
  Case 2 'Windows NT
     Dim cb As Long, cbNeeded As Long, NumElements As Long, ProcessIDs() As Long
     Dim cbNeeded2 As Long, NumElements2 As Long, Modules(1 To 200) As Long
     Dim lRet As Long, ModuleName As String, nSize As Long
     Dim hProcess As Long, i As Long
     'Get the array containing the process id's for each process object
     cb = 8: cbNeeded = 96
     Do While cb <= cbNeeded
        cb = cb * 2: ReDim ProcessIDs(cb / 4) As Long
        lRet = EnumProcesses(ProcessIDs(1), cb, cbNeeded)
     Loop
     NumElements = cbNeeded / 4
     For i = 1 To NumElements
        'Get a handle to the Process
        hProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, ProcessIDs(i))
        'Got a Process handle
        If hProcess <> 0 Then
            'Get an array of the module handles for the specified process
            lRet = EnumProcessModules(hProcess, Modules(1), 200, cbNeeded2)
            'If the Module Array is retrieved, Get the ModuleFileName
            If lRet <> 0 Then
               ModuleName = Space(MAX_PATH): nSize = 500
               lRet = GetModuleFileNameExA(hProcess, Modules(1), ModuleName, nSize)
                sname = Left(ModuleName, lRet)
                If InStr(sname, "WINWORD.EXE") > 0 Then
                  MsgBox ("Word is open. Please close before the O.K. for continuation."): End
                End If
                If InStr(sname, "EXCEL.EXE") > 0 Then
                  MsgBox ("Excel is open. Please close before continuation."): End
                End If
            End If
        End If
        lRet = CloseHandle(hProcess) 'Close the handle to the process
     Next
  End Select
End Sub

Function StrZToStr(ByVal s As String) As String
   StrZToStr = Left(s, Len(s) - 1)
End Function

Public Function getVersion() As Long
   Dim osinfo As OSVERSIONINFO
   Dim retvalue As Integer
   osinfo.dwOSVersionInfoSize = 148
   osinfo.szCSDVersion = Space$(128)
   retvalue = GetVersionExA(osinfo)
   getVersion = osinfo.dwPlatformId
End Function



'************************************************
'  Sub WordTempDateiPrint
'  Prints a temporary file with formatting instructions
'  in a WORD document
'************************************************
Public Sub WordTempDateiPrint(ByVal sW)
  Call Subs("    WordTempDateiPrint " & sW)
  Open sInp For Input As #1
'  With wdAnw
'    .Width = 400: .Height = 550: .Left = 350: .Top = 1
'  End With
  wdAnw.Documents(sW).Activate
  With frmCN2.grdTab3
    .Row = 2: .Col = 0
    If .Text > "" Then .Text = .Text & vbCrLf
    If modu.Calc Then .Text = .Text & sW
  End With
  Do While Not EOF(1)
    Line Input #1, sB           '1 Zeile lesen
    If sB = "" Then
      wdAnw.Documents(sW).Select
      Call LayoutAnsicht        'mit : Layoutansicht
    ElseIf sB = "$!1" Then
'      Selection.InsertFile Filename:="Unc1in.doc", Range:="", ConfirmConversions _
'        :=False, Link:=False, Attachment:=False 'mit $!1: Datei einfgen
    ElseIf InStr(sB, "$") Then
      Call WordFormat           'mit $: Formatangaben
    Else
      Call WordPrint            'sonst: String in Word-Dokument schreiben
      If modu.Calc Then
        If InStr(sB, "......") > 0 Then iGraph = iGraph + 1: Call InsertGraph(iGraph)
      End If
    End If
  Loop: Close 1
End Sub


'************************************************
'  Sub WordPageFormat
'  Fives the formats of a page
'
'************************************************
Public Sub WordPageFormat(ByVal i)                   'Seite einrichten
  With wdAnw.Documents(i).PageSetup
    .LineNumbering.Active = False
    .Orientation = wdOrientPortrait
    .TopMargin = CentimetersToPoints(0.6)
    .BottomMargin = CentimetersToPoints(0.6)
    .LeftMargin = CentimetersToPoints(0.7)
    .RightMargin = CentimetersToPoints(0.7)
    .Gutter = CentimetersToPoints(1.5)
    .HeaderDistance = CentimetersToPoints(0.6)
    .FooterDistance = CentimetersToPoints(0.6)
    .PageWidth = CentimetersToPoints(21)
    .PageHeight = CentimetersToPoints(29.7)
    .FirstPageTray = wdPrinterDefaultBin
    .OtherPagesTray = wdPrinterDefaultBin
    .SectionStart = wdSectionNewPage
    .OddAndEvenPagesHeaderFooter = False
    .DifferentFirstPageHeaderFooter = False
    .VerticalAlignment = wdAlignVerticalTop
    .SuppressEndnotes = False
    .MirrorMargins = True
  End With
  ActiveDocument.DefaultTabStop = CentimetersToPoints(1)
WSEnd:: End Sub


'************************************************
'  Sub WordFormat
'  Sets the format parameters, which are read from string sB
'  Formattes the marked range
'************************************************
Public Sub WordFormat()
  Dim sAlig, sPag, sBold, sItalic, sFont, iFont, iAbs
  iAbs = 0
  sAlig = "L"
  If InStr(sB, "L") Then sAlig = "L"
  If InStr(sB, "R") Then sAlig = "R"
  If InStr(sB, "Z") Then sAlig = "Z"
  If InStr(sB, "B") Then sBold = -1 Else sBold = 0
  If InStr(sB, "I") Then sItalic = -1 Else sItalic = 0
  If InStr(sB, "14") Then iFont = 14: iAbs = 1
  If InStr(sB, "12") Then iFont = 12: iAbs = 3
  If InStr(sB, "11") Then iFont = 11
  If InStr(sB, "10") Then iFont = 10: If InStr(sB, "A") Then iAbs = 6
  If InStr(sB, "9") Then iFont = 9
  If InStr(sB, "8") Then iFont = 8
  If InStr(sB, "7") Then iFont = 7
  If InStr(sB, "6") Then iFont = 6
  If InStr(sB, "A") Then sFont = "Arial"
  If InStr(sB, "C") Then sFont = "Courier New"
  If InStr(sB, "M") Then sFont = "Courier New": '"Monotype.com"
  If InStr(sB, "T") Then sFont = "Times New Roman"
  If InStr(sB, "K") Then sFont = "Arial": sBold = 0: sItalic = -1: sAlig = "R": iFont = 8
  If InStr(sB, "U") Then sAlig = "U"
  If iFont = 0 Then iFont = 10
  If InStr(sB, "K") Then    'Kopfzeile
    wdAnw.Documents(1).Sections(1).Headers(wdHeaderFooterPrimary).Range.Select
  Else
    wdAnw.Documents(1).Select
  End If
  If InStr(sB, "~") Then 'Neue Seite
    sPag = "Y": sB = ""
  End If


'  If InStr(sB, ">") Then 'Tabulator setzen
''    wdAnw.Selection.ParagraphFormat.TabStops.ClearAll
''    ActiveDocument.DefaultTabStop = CentimetersToPoints(2)
''    wdAnw.Selection.ParagraphFormat.TabStops.Add Position:=CentimetersToPoints(4), _
''    Alignment:=wdAlignTabLeft, Leader:=wdTabLeaderSpaces
'
'  Selection.ParagraphFormat.TabStops.ClearAll
'    ActiveDocument.DefaultTabStop = CentimetersToPoints(1)
'    Selection.ParagraphFormat.TabStops.Add Position:=CentimetersToPoints(2), _
'        Alignment:=wdAlignTabLeft, Leader:=wdTabLeaderSpaces
'    Selection.ParagraphFormat.TabStops.Add Position:=CentimetersToPoints(4), _
'        Alignment:=wdAlignTabLeft, Leader:=wdTabLeaderSpaces
'    Selection.ParagraphFormat.TabStops.Add Position:=CentimetersToPoints(6), _
'        Alignment:=wdAlignTabLeft, Leader:=wdTabLeaderSpaces
'    Selection.ParagraphFormat.TabStops.Add Position:=CentimetersToPoints(8), _
'        Alignment:=wdAlignTabLeft, Leader:=wdTabLeaderSpaces
'    Selection.ParagraphFormat.TabStops.Add Position:=CentimetersToPoints(10), _
'        Alignment:=wdAlignTabLeft, Leader:=wdTabLeaderSpaces
'
''Tabulator 2 cm setzen
'  End If
 
  With wdAnw.Selection
    .EndKey unit:=wdStory    'Cursor an das Ende des Dokuments setzen
    .Font.Name = sFont: .Font.Size = iFont
    .Font.Bold = sBold: .Font.Italic = sItalic
    .Font.Underline = wdUnderlineNone
    .ParagraphFormat.SpaceBefore = iAbs
    If sAlig = "R" Then .ParagraphFormat.Alignment = wdAlignParagraphRight
    If sAlig = "L" Then .ParagraphFormat.Alignment = wdAlignParagraphLeft
    If sAlig = "Z" Then .ParagraphFormat.Alignment = wdAlignParagraphCenter
    If sAlig = "U" Then .Font.Underline = wdUnderlineSingle
    If sPag = "Y" Then .InsertBreak Type:=wdPageBreak
    sPag = "-"
  End With
    wdAnw.Selection.WholeStory
    wdAnw.Selection.ParagraphFormat.TabStops.ClearAll
    ActiveDocument.DefaultTabStop = CentimetersToPoints(2)
End Sub


'************************************************
'  Sub WordMain
'  Calls the subs for a WORD report
'  A guide for other programs
'************************************************
Public Sub WordMain()
  Dim strFileW1, strFileW2, Document As Object, Report As Document, sA
  Set wdAnw = CreateObject("Word.Application")
  Call Subs(vbCrLf & "  WordMain" & vbCrLf & "====================")
  Close
  Call JobInput
  With wdAnw
    .Visible = True
'Output for the now calculated nuclides
    For inuc = 1 To nnuc
      iGraph = -1
      If modu.unc Then
        si = "UncWordOut.tmp": sInp = sPfdT & si
        sWD = "Uncert " & NUCLIDE(inuc).FileNam & ".doc"
      Else
        si = "EffWordOut.tmp": sInp = sPfdT & NUCLIDE(inuc).FileNam & si
        sWD = "Output " & NUCLIDE(inuc).FileNam & ".doc"
      End If
      If NUCLIDE(inuc).D = False Then
        .Documents.Add
        .Documents(1).Activate
        Call WordPageFormat(1)
        .Documents(1).SaveAs sPfdA & sWD
        .Documents(sWD).Activate
        Call WordTempDateiPrint(sWD)
        wdAnw.ActiveDocument.Select
        wdAnw.Selection.HomeKey unit:=wdStory 'zurck zum DokumentAnfang
        wdAnw.Documents(sWD).SaveAs sPfdA & sWD 'Speichern
      Else
'        .Documents.Add
      End If
    Next
'Report
    If modu.Rep And modu.wR Then
      sInp = sPfdT & "RepWordOut.tmp": sWR = "Report.doc"
      .Documents.Add
      Call WordPageFormat(1)               'Seite einrichten
      .Documents(1).SaveAs sPfdA & sWR
      .Documents(sWR).Activate
      Call WordTempDateiPrint(sWR)
      wdAnw.ActiveDocument.Select
      wdAnw.Selection.HomeKey unit:=wdStory
      sR = sPfdA & sWR
      Documents(sWR).SaveAs sR
      .Documents(sWD).Activate 'Back to Output protocol
    End If
  End With

End Sub


'************************************************
'  Sub WordPrint
'  Prints a text after the cursor position
'************************************************
Public Sub WordPrint()
  With wdAnw.Selection
    .EndKey unit:=wdStory       'Cursor an das Ende des Dokuments setzen
    .TypeText Text:=sB & vbCrLf 'Text hinter den Cursor schreiben
  End With
End Sub


'************************************************
'  Sub InsertGraph
'  Inserts a HPGL graph after the cursor position
'************************************************
Public Sub InsertGraph(ByVal i)
  wdAnw.ActiveDocument.Tables.Add Range:=wdAnw.Selection.Range, NumRows:=1, NumColumns:=1 'Tabelle mit Grafik
  With wdAnw.Selection.Tables(1)
      .Columns.Width = CentimetersToPoints(10)
      .Borders(wdBorderLeft).LineStyle = wdLineStyleNone
      .Borders(wdBorderRight).LineStyle = wdLineStyleNone
      .Borders(wdBorderTop).LineStyle = wdLineStyleNone
      .Borders(wdBorderBottom).LineStyle = wdLineStyleNone
      .Borders.Shadow = False
  End With
  With wdAnw.Selection.Rows
      .SetLeftIndent LeftIndent:=CentimetersToPoints(5), RulerStyle:=wdAdjustNone
  End With
  wdAnw.Selection.InlineShapes.AddPicture Filename:= _
  sPfdA & sHPGraf(inuc, i), LinkToFile:=False, SaveWithDocument:=True
End Sub
