Attribute VB_Name = "Module6"
Public Type ModuTyp 'Modus of output of remarks
  Calc As Boolean
  unc As Boolean
  UncS As Boolean
  Rep As Boolean
  UncAct As Boolean
  Test As Boolean
  Free As Boolean
  Warn As Boolean 'Warning
  Out As Integer  'Output parameter from file CIENIST.ctl
  OutAct As Integer 'Output in the actual case
  Act As Boolean  'Actual output
  wO As Boolean  'Word output
  Word As Boolean  'Word files
  wR As Boolean  'Word report
  XLS As Boolean  'Excel
  B As Integer  'Beta
  G As Integer  'Gamma
  EC As Integer 'EC
  C As Integer  'Cascades
  ng As Integer 'Highest number of gammas in a cascade
  Is As Integer 'Isomers
  In As Integer 'Input
  Info As Integer 'Info
  OF As Integer 'Output files
  f As Integer  'Fit
  sZ As Integer 'Scintillator
  SPlot As Integer 'Spectrum plot
  q As Integer  'Quench
  CrS As Integer 'Cross sections
  sH As Single  'Short output level (only contributions with p > .sH %)
  part As Integer 'Part of calculation
  Random As Integer 'Random generator mode
End Type

Public Type QuenchDatTyp
  KB As Single
  kBListe As Single
  rkB As Single
  nfm As Single
  fmwert(0 To 200) As Single
  iref As Integer
  iref2 As Integer
  fmRef As Single
  fmRef2 As Single
  Cl(0 To 8) As Double
  cp(0 To 8) As Double
  cg(0 To 8) As Double
  grad As Integer
  PolKoeff(0 To 10) As Single
  E50 As Single
  dE1 As Single
  Source As String
  samp As String
End Type

Public Type CrossSecTyp
  eL As String
  k(1 To 12) As Single
  fak As Single
  Phot As Single
  Comp As Single
  tot As Single
End Type

Public Type EffDatTyp
  nfm As Single
  fmwert(0 To 200) As Single
  EffT(0 To 200) As Single
  EffN(0 To 200) As Single
  iref As Integer
  fmRef As Single
  grad As Integer
  PolKoeff(0 To 10) As Single
  E50 As Single
  dE1 As Single
End Type

Public Type AtomDatTyp
  sA As String 'Output string (with formates)
  wK As Single    'Atomic data
  wL As Single
  nKL As Single
  pKLL As Single
  pKLX As Single
  pKXY As Single
  pKL As Single
  pKX As Single
  EKLL As Single
  EKLX As Single
  EKXY As Single
  ELXY As Single
  EKL As Single
  EKX As Single
  ELX As Single
  wKu As Single   'Uncertainties absolute
  wLu As Single
  pKLLu As Single
  pKLXu As Single
  pKXYu As Single
  pKLu As Single
  pKXu As Single
  EKLLu As Single
  EKLXu As Single
  EKXYu As Single
  ELXYu As Single
  EKLu As Single
  EKXu As Single
  ELXu As Single
  EffKLL As Single  'Efficiencies (nur fr Preview)
  EffKLX As Single
  EffKXY As Single
  EffLXY As Single
  EffKL As Single
  EffKX As Single
  EffLX As Single
  pEscKL As Single  'Escape probabilities
  pEscKX As Single
  pEscLX As Single
  EK As Single      'Binding electron energies
  eL As Single
  EM As Single
  pK As Single      'EC probabilities
  pL As Single
  pM As Single
  pN As Single
  Unc2 As Single     'Uncertainty contribution (fm=1.6)
  RUnc2 As Single    'Rel.Uncertainty of EffRef (fm=1.6)
  ESpekt(1 To 3, 0 To 100) As Single
End Type

Public Type AtomDatTyp2
  wK As Single
  wL(1 To 3) As Single
'  wL1  wL2  wL3 As Single
  nKL As Single
  pKXY(1 To 10) As Single
'  pKL1L1  pKL1L2  pKL1L3  pKL2L2  pKL2L3  pKL3L3  pKL1M  pKL2M  pKL3M  pKMM As Single +
  EKXY(1 To 10) As Single
'  EKL1L1  EKL1L2  EKL1L3  EKL2L2  EKL2L3  EKL3L3  EKL1M  EKL2M  EKL3M  EKMM As Single +
  EffKXY(1 To 10) As Single
'  ebenso wie pKXY()
  pLMM(1 To 3) As Single
'  pL1MM  pL2MM  pL3MM  As Single
  ELLM(1 To 3) As Single
'  EL1L2M  EL1L3M  EL2L3M  As Single
  ELMM(1 To 3) As Single
'  EL1MM  EL2MM  EL3MM  As Single
  EffLMM(1 To 10) As Single
'  ebenso wie pLMM()
  pKX(1 To 4) As Single
'  pKL1  pKL2  pKL3  pKM as single
  EKX(1 To 4) As Single
'  EKL1  EKL2  EKL3  EKM as single
  EffKX(1 To 4) As Single
'  ebenso wie pKX
  ELM(1 To 3) As Single
'  EL1M  EL2M  EL3M  As Single
  pEscKX(1 To 4) As Single
'  ebenso wie pKX
  EK As Single
  eL As Single
  EM As Single
  pK As Single
  pL As Single
  pM As Single
  pN As Single
  ESpekt(1 To 3, 0 To 100) As Single
End Type

Public Type TracDatTyp
  KB As Single
  ZB(0 To 20) As Single
  ZB2(0 To 20) As Single
End Type

Public Type AlphaDatTyp
  sA As String 'Output string (with formates)
  Name As Integer
  E As Single
  p As Single
  Unc2 As Single         'uncertainty contribution (fm=1.6)
  RUnc2 As Single        'Rel.Uncertainty of Eff* (fm=1.6)
  EffRef As Single      'Efficiency for fmRef
  EffRef2 As Single     'Efficiency for fm 1.6
  ZA(0 To 200) As Single
  ZA2(0 To 200) As Single
End Type

Public Type BetaDatTyp
  sA As String 'Output string (with formates)
  Name As Integer
  EMax As Single
  EMaxU As Single
  shape As Variant
  EAve As Single
  p As Single
  Unc2 As Single         'uncertainty contribution (fm=1.6)
  RUnc2 As Single        'Rel.Uncertainty of Eff* (fm=1.6)
  EffRef As Single      'Efficiency for fmRef
  EffRef2 As Single     'Efficiency for fm 1.6
  ZB(0 To 200) As Single
  ZB2(0 To 200) As Single
End Type


Public Type ECDatTyp
  sA As String 'Output string (with formates)
  Name As Integer
  pK As Single
  pKu As Single
  pL As Single
  pM As Single
  pN As Single
  p As Single
  q As Single
  Unc2 As Single         'uncertainty contribution (fm=1.6)
  RUnc2 As Single        'Rel.Uncertainty of Eff* (fm=1.6)
  EffRef As Single      'Efficiency for fmRef
  EffRef2 As Single     'Efficiency for fm 1.6
  ZE(0 To 200) As Single
  ZE2(0 To 200) As Single
End Type

Public Type GammaDatTyp
  sA As String 'Output string (with formates)
  Name As Integer
  E As Single
  Eu As Single
  aTot As Single
  aK As Single
  aL As Single
  aM As Single
  aTotU As Single
  aKu As Single
  aLu As Single
  aMu As Single
  pIC As Single
  IP As Single
  p As Single
  f As Single
  EffRef As Single      'Efficiency for fmRef
  EffRef2 As Single     'Efficiency for fm 1.6
  zP(0 To 200) As Single
  ZP2(0 To 200) As Single
  ZI(0 To 200) As Single
  ZI2(0 To 200) As Single
  Unc2 As Single         'uncertainty contribution (fm=1.6)
  RUnc2 As Single        'Rel.Uncertainty of Eff* (fm=1.6)
End Type

Public Type CascDatTyp
  sA As String 'Output string (with formates)
  p As Single
  pU As Single
  pNorm As Single       'Input p uncertainty
  contr As Single
  E As Single
  nB As Integer
  nEC As Integer
  ng As Integer
  Nam As String
  Na As String
  NamA As Integer
  NamB As Integer
  NamEC As Integer
  NamGF(0 To 12) As Integer
  NumGF(0 To 12) As Integer
  NumF(0 To 12) As Integer
  aTotF(0 To 12) As Single
  EffRef As Single      'Efficiency for fmRef
  EffRef2 As Single     'Efficiency for fm 1.6
  Unc2 As Single         'uncertainty contribution of the single cascade (fm=1.6)
  RUnc2 As Single        'Rel.Uncertainty of Eff* (fm=1.6)
  x As Single           ' Eff for calculation
  u1 As Single          ' unc 1
  u2 As Single          'Unc2 (due to .pU)
End Type

Public Type IsomerDatTyp
  sA As String 'Output string (with formates)
  p As Single
  pU As Single
  pNorm As Single
  contr As Single
  E As Single
  nB As Integer
  nEC As Integer
  ng As Integer
  Nam As String
  NamB As Integer
  NamEC As Integer
  NamGF(0 To 12) As String
  NumGF(0 To 12) As Integer
  NumF(0 To 12) As Integer
  aTotF(0 To 12) As Single
  EffRef As Single    'Efficiency for fmRef
  EffRef2 As Single      'Efficiency for fm 1.6
  Unc2 As Single       'uncertainty contribution (fm=1.6)
  RUnc2 As Single      'Rel.Uncertainty of Eff* (fm=1.6)
  x As Single           ' Eff for calculation
  u1 As Single          ' unc 1
  u2 As Single          'Unc2 (due to .pU)
End Type

Public Type Nuclidetype
  Nuc As Variant
  Nam As String
  Text As String
  FileNam As String 'FileName for the nuclide
  hgl As String 'FileName for the efficienca HPGL plot
  sA As String  'Output string (with formates)
  Gen As Boolean 'Genetic Mother/Daughter
  M As Boolean  'Mother nuclide
  D As Boolean  'Daughter nuclide
  z As Integer
  aM As Single
  nCTL As String 'Number of CTL set
  T12 As String  'Half-life in days
  nAlpha As Integer
  nBeta As Integer
  nEC As Integer
  ngamma As Integer
  nCasc As Integer
  nCascGam As Integer 'max number of Gammas /Cascade
  nIsom As Integer
  nIsomGam As Integer 'max number of Gammas /Cascade
  EffRef As Single    'Efficiency for fmRef
  EffRef2 As Single   'Efficiency for fm 1.6
  Unc2 As Single       'Uncertainty of Eff* (fm=1.6)
  RUnc2 As Single      'Rel.Uncertainty of Eff* (fm=1.6)
  Found As Boolean
  xSp(0 To 1, 0 To 400) As Double 'Elektronenspektrum
End Type

Public Type CascExcelTyp
  n As Integer
  sum As Single
  w(0 To 20) As String
  p(0 To 20) As Single
  C(0 To 20) As Single
End Type

Public Type MesTyp
  pf As String * 40
  ctl As String * 12
  Nuc As String * 8
  aus As Single
  datc As String * 12
  datn As String * 12
End Type

Public Type SciDatTyp
  Nr As Integer
  Name As String * 8
  VolSci As Single
  VolWat As Single
  strSamp As String * 8
  sSamp As String * 8
  D As Single
  pEl(1 To 9) As Single
  z(1 To 9) As Single
  Mol(1 To 9) As Single
  h As Single
  C As Single
  n As Single
  O As Single
  Na As Single
  p As Single
  s As Single
  Cl As Single
  k As Single
  Rema As String
End Type

Public Type WayTyp
  path As String
  pEC As Single
  EffEnEC As Single
  ContrEC As Single
  pIC As Single
  EffEnIC As Single
  ContrIC As Single
End Type

Public Type OutputTyp
  sHead As String
  sNuc As String
  sBeta As String
  sEC As String
  sGam As String
  sCasc As String
  sEff As String
  sUnc As String
  sRem As String
End Type
